// 
// zǌn}\pCvȊO̗vfiQj\NX
// 
// AisleSpace.java
// 
// PipingDiagram.javaNXŎgp
// 
// 
// Bww@Hw@CmVXeHw
// ؑ@
// kimura@nams.kyushu-u.ac.jp
// http://sysplan.nams.kyushu-u.ac.jp/gen/index.html
//
//---------------------------------------------------

import java.lang.Math ;
import java.io.* ;
import java.util.*;
// import MT19937 ; // double uniformRandomNumber  = MT19937.uniform() ; // 0-1̈l

import javax.xml.parsers.*;  // XMLp|T[֘ÃNX
import org.w3c.dom.*;        // XMLp|T[֘ÃNX


//-----------------------------------------

public class AisleSpace {

	//------ϐ
	public double x_min ;
	public double x_max ;
	public double y_min ;
	public double y_max ;
	public double z_min ;
	public double z_max ;
	public String Specification ;
	public String pid ;
	public double exValue ;

	//-----------------------RXgN^
	AisleSpace(){
		Specification = "" ;
	}
	//----------------------------------------------
	// XMLp[T"AisleSpace"ƃxtꂽ
	// m[hElementlǂݍ
	//----------------------------------------------
	public void loadFromXMLelement( Element AisleSpaceElement ){
		// pid̒l擾
		pid = AisleSpaceElement.getAttribute("pid").trim();
//		System.out.println( "pid = " + pid );
		//----Specificationvf̃Xg擾
		NodeList list_Specification = AisleSpaceElement.getElementsByTagName("Specification");
		// ŏSpecificationǂݍ
		if( list_Specification.getLength() > 0 ){
			// Specificationvf擾
			Element element = (Element)list_Specification.item(0);
			// Specificationvf̍ŏ̎qm[hieLXgm[hj̒l擾
			Specification = element.getFirstChild().getNodeValue();
		}
		// ExtraValuevf̃Xg擾
		NodeList list_ExtraValue = AisleSpaceElement.getElementsByTagName("ExtraValue");
		// ŏExtraValueǂݍ
		if( list_ExtraValue.getLength() > 0 ){
			Element ExtraValueElement = (Element)list_ExtraValue.item(0);
			// ExtraValuevf擾
			String str = ExtraValueElement.getFirstChild().getNodeValue();
			exValue = Double.valueOf( str ).doubleValue() ;
		}
		// BoundingBoxvf̃Xg擾
		NodeList list_BoundingBox = AisleSpaceElement.getElementsByTagName("BoundingBox");
		// ŏBoundingBoxǂݍ
		if( list_BoundingBox.getLength() > 0 ){
			// BoundingBoxvf擾
			Element element = (Element)list_BoundingBox.item(0);
			// x_minvf̃Xg擾--------------------------------
			NodeList x_minList = element.getElementsByTagName("x_min");
			if( x_minList.getLength() > 0 ){
				// x_minvf擾
				Element x_minElement = (Element)x_minList.item(0);
				// x_minvf̍ŏ̎qm[hieLXgm[hj̒l擾
				String str = x_minElement.getFirstChild().getNodeValue();
				x_min = Double.valueOf( str ).doubleValue() ;
			}
			// x_maxvf̃Xg擾--------------------------------
			NodeList x_maxList = element.getElementsByTagName("x_max");
			if( x_maxList.getLength() > 0 ){
				// x_maxvf擾
				Element x_maxElement = (Element)x_maxList.item(0);
				// x_maxvf̍ŏ̎qm[hieLXgm[hj̒l擾
				String str = x_maxElement.getFirstChild().getNodeValue();
				x_max = Double.valueOf( str ).doubleValue() ;
			}
			if( x_min > x_max ){
				double tmp = x_min;
				x_min = x_max;
				x_max = tmp ;
			}
			// y_minvf̃Xg擾--------------------------------
			NodeList y_minList = element.getElementsByTagName("y_min");
			if( y_minList.getLength() > 0 ){
				// y_minvf擾
				Element y_minElement = (Element)y_minList.item(0);
				// y_minvf̍ŏ̎qm[hieLXgm[hj̒l擾
				String str = y_minElement.getFirstChild().getNodeValue();
				y_min = Double.valueOf( str ).doubleValue() ;
			}
			// y_maxvf̃Xg擾--------------------------------
			NodeList y_maxList = element.getElementsByTagName("y_max");
			if( y_maxList.getLength() > 0 ){
				// y_maxvf擾
				Element y_maxElement = (Element)y_maxList.item(0);
				// y_maxvf̍ŏ̎qm[hieLXgm[hj̒l擾
				String str = y_maxElement.getFirstChild().getNodeValue();
				y_max = Double.valueOf( str ).doubleValue() ;
			}
			if( y_min > y_max ){
				double tmp = y_min;
				y_min = y_max;
				y_max = tmp ;
			}
			// z_minvf̃Xg擾--------------------------------
			NodeList z_minList = element.getElementsByTagName("z_min");
			if( z_minList.getLength() > 0 ){
				// z_minvf擾
				Element z_minElement = (Element)z_minList.item(0);
				// z_minvf̍ŏ̎qm[hieLXgm[hj̒l擾
				String str = z_minElement.getFirstChild().getNodeValue();
				z_min = Double.valueOf( str ).doubleValue() ;
			}
			// z_maxvf̃Xg擾--------------------------------
			NodeList z_maxList = element.getElementsByTagName("z_max");
			if( z_maxList.getLength() > 0 ){
				// z_maxvf擾
				Element z_maxElement = (Element)z_maxList.item(0);
				// z_maxvf̍ŏ̎qm[hieLXgm[hj̒l擾
				String str = z_maxElement.getFirstChild().getNodeValue();
				z_max = Double.valueOf( str ).doubleValue() ;
			}
			if( z_min > z_max ){
				double tmp = z_min;
				z_min = z_max;
				z_max = tmp ;
			}
		}
	}

	//-----------------------------------------------
	// ڐG̔ ̔ƐڐGĂtrueԂ
	//-----------------------------------------------
	public boolean interfere( double ix_min, double ix_max, double iy_min, double iy_max, double iz_min, double iz_max ){ 
		if( ix_min >= x_max ){ return( false );}
		if( ix_max <= x_min ){ return( false );}
		if( iy_min >= y_max ){ return( false );}
		if( iy_max <= y_min ){ return( false );}
		if( iz_min >= z_max ){ return( false );}
		if( iz_max <= z_min ){ return( false );}
		return( true );
	}


	//----------------------------------------------
	public String getXMLString(){
		StringBuffer strBuf = new StringBuffer() ;
		strBuf.append("<AisleSpace pid=\"" ).append( pid ).append("\" > \n" );
		if( Specification.length() > 0 ){
			strBuf.append("<Specification>").append( Specification ).append("</Specification> \n") ;
		}
		strBuf.append("<ExtraValue> ") .append( exValue ).append(" </ExtraValue> \n") ;
		strBuf.append("<BoundingBox> \n") ;
		strBuf.append("<x_min>  ").append( x_min ).append("  </x_min>  ") ;
		strBuf.append("<x_max>  ").append( x_max ).append("  </x_max> \n") ;
		strBuf.append("<y_min>  ").append( y_min ).append("  </y_min>  ") ;
		strBuf.append("<y_max>  ").append( y_max ).append("  </y_max> \n") ;
		strBuf.append("<z_min>  ").append( z_min ).append("  </z_min>  ") ;
		strBuf.append("<z_max>  ").append( z_max ).append("  </z_max> \n") ;
		strBuf.append("</BoundingBox> \n") ;
		strBuf.append("</AisleSpace> \n" );
		return( strBuf.toString() );
	}
	//----------------------------------------------
	public String getX3DString(){
		StringBuffer strBuf = new StringBuffer() ;
		double width  = x_max - x_min ;
		double height = z_max - z_min ;
		double depth  = y_max - y_min ;
		strBuf.append("<Transform translation=\"" );
		strBuf.append( x_min +width/2).append(" ") ;
		strBuf.append( z_min +height/2).append(" ") ;
		strBuf.append( y_min +depth/2).append("\">\n") ;
		strBuf.append("<Shape> \n" );
		strBuf.append("<Box size=\"") ;
		strBuf.append( width ).append(" ") ;
		strBuf.append( height).append(" ") ;
		strBuf.append( depth ).append("\"/>\n") ;
		strBuf.append("<Appearance>\n");
		strBuf.append("<Material diffuseColor = '0.2 0.2 1.0' transparency = '0.5'/>\n");
		strBuf.append("</Appearance>\n");
		strBuf.append("</Shape> \n" );
		strBuf.append("</Transform>\n" );
		return( strBuf.toString() );
	}


}
