// 
// [eBONX
// 
// AutomaticRouting.java
// 
// 
// 
//
// ȉ̃NXgp
// 
// 
// Pipe
// BoxelSpace
// 

import java.lang.Math ;
import java.io.* ;
import java.util.*;
// import MT19937 ; // double uniformRandomNumber  = MT19937.uniform() ; // 0-1̈l

import javax.xml.parsers.*;  // XMLp|T[֘ÃNX
import org.w3c.dom.*;        // XMLp|T[֘ÃNX
import java.text.DecimalFormat;
//-------------------------------------------------------------------------------

public class AllItems {

	//-----
	public PipingDiagram pid;
//	public Vector<DesignSpace> DesignSpace;	// ݌vΏۋ
	public Vector<AisleSpace> AisleSpaces;  // ʘH
	public Vector<PipeRackArea> PipeRackAreas ;	// pCvbN
//	public Vector<Equipment> Equipments      ; // pCvȊŐ@(Valve,T-branch,Pump,Inlet-Outlet)
	public Vector<ObstacleBox> ObstacleBoxes ; // Q
	public Vector<ObstacleTriangle> ObstacleTriangles ; // Op`Q
	public Vector<PipeLine> PipeLines;
	public Vector<Pipe> Pipes;
	public Vector<PipePiece> PipePieces ;

	public static final short OBSTACLE   = -1 ;

	//-----------------RXgN^
	AllItems(){
		pid		  = new PipingDiagram();

//		DesignSpace	  = new Vector<DesignSpace>();	//Ώۋ
		AisleSpaces       = new Vector<AisleSpace>();       // ʘH
		PipeRackAreas	  = new Vector<PipeRackArea>();	//pCvbN
//		Equipments        = new Vector<Equipment>();   // pCvȊŐ@(Valve,T-branch,Pump,Inlet-Outlet)
//		ObstacleBoxes     = new Vector<ObstacleBox>(); // Q
//		ObstacleTriangles = new Vector<ObstacleTriangle>(); // Op`Q
		PipeLines	  = new Vector<PipeLine>();
		Pipes		  = new Vector<Pipe>();
		PipePieces	  = new Vector<PipePiece>();

	}
	//---------------------------------



	public void loadFromXMLfile( String filename ){
	
		pid = new PipingDiagram() ;   // n}NXV쐬
		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();

			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();

			// p[XsDocumentIuWFNg擾
			Document doc = builder.parse(new File( filename ));

			// [gvf擾i^OFPlotPlanj
			Element root = doc.getDocumentElement();
			System.out.println("TagName of the root element is: " + root.getTagName());
			if( root.getTagName().equals("PipesAndEquipments") ){

				//---------------------------------------------------
				// DesignSpacevf̃Xg擾
				NodeList list = root.getElementsByTagName("DesignSpace");
				DesignSpace aDesignSpace = new DesignSpace() ; // 
				Element DesignSpaceElement = (Element)list.item(0);
//				System.out.println("getting TagName: " + DesignSpaceElement.getTagName());
				//-----XMLp[T"DesignSpac"ƃxtꂽm[hElementlǂݍ
				aDesignSpace.loadFromXMLelement( DesignSpaceElement );
				pid.DesignSpace.addElement( aDesignSpace );
//		System.out.println(DesignSpace.x_mesh);
				//---------------------DesignSpacevf͂܂

				//---------------------------------------------------
				// Aislevf̃Xg擾
				list = root.getElementsByTagName("AisleSpace");
				// Aislevf̐[v
				for (int i=0; i < list.getLength() ; i++) {
					AisleSpace anAisleSpace = new AisleSpace() ; // 
					Element AisleSpaceElement = (Element)list.item(i);
//					System.out.println("getting TagName: " + AisleElement.getTagName());
					//-----XMLp[T"Aisle"ƃxtꂽm[hElementlǂݍ
					anAisleSpace.loadFromXMLelement( AisleSpaceElement );
					AisleSpaces.addElement( anAisleSpace );
				}//---------------------Aislevf͂܂


				//---------------------------------------------------
				// ObstacleBoxvf̃Xg擾
				list = root.getElementsByTagName("ObstacleBox");
				// ObstacleBoxvf̐[v
				for (int i=0; i < list.getLength() ; i++) {
					ObstacleBox anObstacleBox = new ObstacleBox() ; // 
					Element ObstacleBoxElement = (Element)list.item(i);
					//-----XMLp[T"ObstacleBox"ƃxtꂽm[hElementlǂݍ
					anObstacleBox.loadFromXMLelement( ObstacleBoxElement );
					pid.ObstacleBoxes.addElement( anObstacleBox );
				} //-------ObstacleBoxvf̉͂܂
				//---------------------------------------------------

				//---------ObstacleTrianglevf̃Xg擾
				list = root.getElementsByTagName("ObstacleTriangle");
				// ObstacleTrianglevf̐[v
				for (int i=0; i < list.getLength() ; i++) {
					ObstacleTriangle anObstacleTriangle = new ObstacleTriangle() ; // 
					Element ObstacleTriangleElement = (Element)list.item(i);
					//-----XMLp[T"ObstacleTriangle"ƃxtꂽm[hElementlǂݍ
					anObstacleTriangle.loadFromXMLelement( ObstacleTriangleElement );
					pid.ObstacleTriangles.addElement( anObstacleTriangle );
				} //-------ObstacleTrianglevf̉͂܂


				//---------------------------------------------------
				// PipeRackAreavf̃Xg擾
				list = root.getElementsByTagName("PipeRackArea");
//				System.out.println("numOfPipeRackArea = " + list.getLength());
				// PipeRackAreavf̐[v
				for (int i=0; i < list.getLength() ; i++) {
					PipeRackArea aPipeRackArea = new PipeRackArea() ; // 
					Element PipeRackAreaElement = (Element)list.item(i);
					//-----XMLp[T"PipeRackArea"ƃxtꂽm[hElementlǂݍ
					aPipeRackArea.loadFromXMLelement( PipeRackAreaElement );
					PipeRackAreas.addElement( aPipeRackArea );
				} //-------ObstacleBoxvf̉͂܂


				//---------------------------------------------------
				// PipeLinevf̃Xg擾
				list = root.getElementsByTagName("PipeLine");
				// PipeLinevf̐[v
				for (int i=0; i < list.getLength() ; i++) {
					Element PipeLineElement = (Element)list.item(i);
//					System.out.println("getting TagName: " + PipeElement.getTagName());
					PipeLine aPipeLine = new PipeLine() ; // 
					//-----XMLp[T"PipeLine"ƃxtꂽm[hElementlǂݍ
					aPipeLine.loadFromXMLelement( PipeLineElement );
					PipeLines.addElement( aPipeLine );
				} //----PipeLinevf̉͂܂
//System.out.println(" PipeHonsu = " + PipeLines.size() );
//System.out.println(" tyokei = " + PipeLines.elementAt(0).Pipes.elementAt(0).Diameter );
//System.out.println(" honsu = " + PipeLines.elementAt(0).Pipes.size() );


/**
				//-----PipeIuWFNg̎n_EI_ɑEquipment|C^RlN^No.ɒl蓖Ă
				if( tiePipesToEquipments() > 0 ){
					System.out.println("---------WARNING!! Start or end points of pipes do not match with the equipments.");
				}
*/

			}else{
				System.out.println("Cannot read this Root TagName! It should be <PipesAndEquipments>.");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	


	//----------------------------------------------------------------
	public String getXMLString( String comment ){
		StringBuffer strBuf = new StringBuffer() ;
//		System.out.println("flag");
		strBuf.append("<?xml version=\"1.0\" encoding=\"x-sjis\" standalone=\"yes\" ?> \n" );
		strBuf.append("<!DOCTYPE PlotPlan SYSTEM \"./PipesAndEquipments.dtd\"> \n" );
		strBuf.append("<!-- ").append( comment ).append(" --> \n" );
		strBuf.append("<PipesAndEquipments> \n" );

			//--- DesignSpace
			strBuf.append("\n<!-- DesignSpace --> \n" ) ;
			DesignSpace aDesignSpace = pid.DesignSpace.elementAt( 0 );
			strBuf.append( aDesignSpace.getXMLString() );

			//--- Aisle
			strBuf.append("\n<!-- Aisle(s) --> \n" ) ;
			for( int index = 0; index < AisleSpaces.size(); index++ ){
				AisleSpace anAisleSpace = AisleSpaces.elementAt( index );
				strBuf.append( anAisleSpace.getXMLString() );
			}

			//--- ObstacleBox
			strBuf.append("\n<!-- ObstacleBox(es) --> \n" ) ;
			for( int index = 0; index < pid.ObstacleBoxes.size(); index++ ){
				ObstacleBox anObstacleBox = pid.ObstacleBoxes.elementAt( index );
				strBuf.append( anObstacleBox.getXMLString() );
			}
/**
			//--- ObstacleTriangle
			strBuf.append("\n<!-- ObstacleTriangle(s) --> \n" ) ;
			for( int index = 0; index < pid.ObstacleTriangles.size(); index++ ){
				ObstacleTriangle anObstacleTriangle = pid.ObstacleTriangles.elementAt( index );
				strBuf.append( anObstacleTriangle.getXMLString() );
			}
*/
			//--- PipeRackArea
			strBuf.append("\n<!-- PipeRackArea(s) --> \n" ) ;
			for( int index = 0; index < PipeRackAreas.size(); index++ ){
				PipeRackArea aPipeRackArea = PipeRackAreas.elementAt( index );
				strBuf.append( aPipeRackArea.getXMLString() );
			}


			//--- PipeRoutes(s)
			strBuf.append("\n<!-- PipeRoutes(s) --> \n" ) ;
			for( int index = 0; index < PipeLines.size(); index++ ){
				PipeLine aPipeLine = PipeLines.elementAt( index );
				strBuf.append( aPipeLine.getXMLString() );
			}


		strBuf.append("</PipesAndEquipments> \n" );
		//-----------
		return( strBuf.toString() );
	}

	//------------------X3D̕𐶐
	public String getX3DString( String comment ){
		StringBuffer strBuf = new StringBuffer() ;
//		strBuf.append("<?xml version=\"1.0\" encoding=\"x-sjis\"?> \n" ); // {R[hƃG[œǂ߂Ȃ
//		strBuf.append("<?xml version=\"1.0\"?> \n" );
//		strBuf.append("<X3D>\n" );
//		strBuf.append("<Scene>\n" );
		strBuf.append("<!-- ").append( comment ).append(" --> \n" );
//		strBuf.append("<Background skyColor=\"0 1 1\" groundColor=\"0.5 0.5 0\" />\n");

			//--- Axes And Grid
			strBuf.append("\n<!-- DesignSpace --> \n" ) ;
			DesignSpace aDesignSpace = pid.DesignSpace.elementAt( 0 );
			strBuf.append( aDesignSpace.getDesignOfX3DString() );

			//--- DesignSpace
			strBuf.append("\n<!-- DesignSpace --> \n" ) ;
			strBuf.append( aDesignSpace.getX3DString() );

			//--- Aisle
			strBuf.append("\n<!-- Aisle(s) --> \n" ) ;
//			System.out.println("AisleSpaces.size() = " + AisleSpaces.size());
			for( int index = 0; index < AisleSpaces.size(); index++ ){
				AisleSpace anAisleSpace = AisleSpaces.elementAt( index );
				strBuf.append( anAisleSpace.getX3DString() );
			}


			//--- ObstacleBox
			strBuf.append("\n<!-- ObstacleBox(es) --> \n" ) ;
//			System.out.println("ObstacleBoxes.size() = " + pid.ObstacleBoxes.size());
			for( int index = 0; index < pid.ObstacleBoxes.size(); index++ ){
				ObstacleBox anObstacleBox = pid.ObstacleBoxes.elementAt( index );
				strBuf.append( anObstacleBox.getX3DString() );
			}

			//--- ObstacleTriangle
			strBuf.append("\n<!-- ObstacleTriangle(s) --> \n" ) ;
			for( int index = 0; index < pid.ObstacleTriangles.size(); index++ ){
				ObstacleTriangle anObstacleTriangle = pid.ObstacleTriangles.elementAt( index );
				strBuf.append( anObstacleTriangle.getX3DString() );
			}


			//--- PipeRackArea
			strBuf.append("\n<!-- PipeRackArea(s) --> \n" ) ;
			for( int index = 0; index < PipeRackAreas.size(); index++ ){
				PipeRackArea aPipeRackArea = PipeRackAreas.elementAt( index );
				strBuf.append( aPipeRackArea.getX3DString() );
			}


			//--- PipeRoutes(s)
			strBuf.append("\n<!-- PipeRoutes(s) --> \n" ) ;
			for( int index = 0; index < PipeLines.size(); index++ ){
				PipeLine aPipeLine = PipeLines.elementAt( index );
				strBuf.append( aPipeLine.getX3DString() );
			}


//		strBuf.append("</Scene> \n" );
//		strBuf.append("</X3D> \n" );
		//-----------
		return( strBuf.toString() );
	}

}