// 
// [eBONX
// 
// AutomaticRouting.java
// 
// 
// 
//
// ȉ̃NXgp
// 
// 
// Pipe
// BoxelSpace
// 

import java.lang.Math ;
import java.io.* ;
import java.util.*;
// import MT19937 ; // double uniformRandomNumber  = MT19937.uniform() ; // 0-1̈l

import javax.xml.parsers.*;  // XMLp|T[֘ÃNX
import org.w3c.dom.*;        // XMLp|T[֘ÃNX
import java.text.DecimalFormat;
//-------------------------------------------------------------------------------

public class AutomaticRouting {

	//-----
	public AllItems allItems ;
	public PipingDiagram pid;


//	public Vector<DesignSpace> DesignSpace;	// ݌vΏۋ
	public Vector<AisleSpace> AisleSpaces;  // ʘH
	public Vector<PipeRackArea> PipeRackAreas ;	// pCvbN
//	public Vector<Equipment> Equipments      ; // pCvȊŐ@(Valve,T-branch,Pump,Inlet-Outlet)
//	public Vector<ObstacleBox> ObstacleBoxes ; // Q
//	public Vector<ObstacleTriangle> ObstacleTriangles ; // Op`Q
	public Vector<PipeLine> PipeLines;
	public Vector<Pipe> Pipes;
	public Vector<PipePiece> PipePieces ;

	public static final short OBSTACLE   = -1 ;

	double x_max ;
	double y_max ;
	double z_max ;
	double x_min ;
	double y_min ;
	double z_min ;

	//-----------------RXgN^
	AutomaticRouting(){
		allItems	  = new AllItems() ;
		pid		  = new PipingDiagram();

//		DesignSpace	  = new Vector<DesignSpace>();	//Ώۋ
		AisleSpaces       = new Vector<AisleSpace>();       // ʘH
		PipeRackAreas	  = new Vector<PipeRackArea>();	//pCvbN
//		Equipments        = new Vector<Equipment>();   // pCvȊŐ@(Valve,T-branch,Pump,Inlet-Outlet)
//		ObstacleBoxes     = new Vector<ObstacleBox>(); // Q
//		ObstacleTriangles = new Vector<ObstacleTriangle>(); // Op`Q
		PipeLines	  = new Vector<PipeLine>();
		Pipes		  = new Vector<Pipe>();
		PipePieces	  = new Vector<PipePiece>();

	}
	//---------------------------------



	public void loadFromXMLfile( String filename, AllItems allItems_origin ){
		allItems = allItems_origin ;
		pid = new PipingDiagram() ;   // n}NXV쐬
		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();

			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();

			// p[XsDocumentIuWFNg擾
			Document doc = builder.parse(new File( filename ));

			// [gvf擾i^OFPlotPlanj
			Element root = doc.getDocumentElement();
			System.out.println("TagName of the root element is: " + root.getTagName());
			if( root.getTagName().equals("PipesAndEquipments") ){

				//---------------------------------------------------
				// DesignSpacevf̃Xg擾
				NodeList list = root.getElementsByTagName("DesignSpace");
				DesignSpace aDesignSpace = new DesignSpace() ; // 
				Element DesignSpaceElement = (Element)list.item(0);
//				System.out.println("getting TagName: " + DesignSpaceElement.getTagName());
				//-----XMLp[T"DesignSpac"ƃxtꂽm[hElementlǂݍ
				aDesignSpace.loadFromXMLelement( DesignSpaceElement );
				allItems.pid.DesignSpace.addElement( aDesignSpace );
double x_test = allItems.pid.DesignSpace.elementAt(0).x_max;
//System.out.println("x_test = "+ x_test);
//		System.out.println(DesignSpace.x_mesh);
				//---------------------DesignSpacevf͂܂

				//---------------------------------------------------
				// Aislevf̃Xg擾
				list = root.getElementsByTagName("AisleSpace");
System.out.println(" Num. of AisleSpaces = " + list.getLength() ) ;
				// Aislevf̐[v
				for (int i=0; i < list.getLength() ; i++) {
					AisleSpace anAisleSpace = new AisleSpace() ; // 
					Element AisleSpaceElement = (Element)list.item(i);
//					System.out.println("getting TagName: " + AisleElement.getTagName());
					//-----XMLp[T"Aisle"ƃxtꂽm[hElementlǂݍ
					anAisleSpace.loadFromXMLelement( AisleSpaceElement );
					allItems.AisleSpaces.addElement( anAisleSpace );
				}//---------------------Aislevf͂܂


				//---------------------------------------------------
				// ObstacleBoxvf̃Xg擾
				list = root.getElementsByTagName("ObstacleBox");
System.out.println(" Num. of ObstacleBoxes = " + list.getLength() ) ;
				// ObstacleBoxvf̐[v
				for (int i=0; i < list.getLength() ; i++) {
					ObstacleBox anObstacleBox = new ObstacleBox() ; // 
					Element ObstacleBoxElement = (Element)list.item(i);
					//-----XMLp[T"ObstacleBox"ƃxtꂽm[hElementlǂݍ
					anObstacleBox.loadFromXMLelement( ObstacleBoxElement );
					allItems.pid.ObstacleBoxes.addElement( anObstacleBox );
				} //-------ObstacleBoxvf̉͂܂
				//---------------------------------------------------

				//---------ObstacleTrianglevf̃Xg擾
				list = root.getElementsByTagName("ObstacleTriangle");
System.out.println(" Num. of ObstacleTriangles = " + list.getLength() ) ;
				// ObstacleTrianglevf̐[v
				for (int i=0; i < list.getLength() ; i++) {
					ObstacleTriangle anObstacleTriangle = new ObstacleTriangle() ; // 
					Element ObstacleTriangleElement = (Element)list.item(i);
					//-----XMLp[T"ObstacleTriangle"ƃxtꂽm[hElementlǂݍ
					anObstacleTriangle.loadFromXMLelement( ObstacleTriangleElement );
					allItems.pid.ObstacleTriangles.addElement( anObstacleTriangle );
				} //-------ObstacleTrianglevf̉͂܂


				//---------------------------------------------------
				// PipeRackAreavf̃Xg擾
				list = root.getElementsByTagName("PipeRackArea");
System.out.println(" Num. of PipeRackAreas = " + list.getLength() ) ;
//				System.out.println("numOfPipeRackArea = " + list.getLength());
				// PipeRackAreavf̐[v
				for (int i=0; i < list.getLength() ; i++) {
					PipeRackArea aPipeRackArea = new PipeRackArea() ; // 
					Element PipeRackAreaElement = (Element)list.item(i);
					//-----XMLp[T"PipeRackArea"ƃxtꂽm[hElementlǂݍ
					aPipeRackArea.loadFromXMLelement( PipeRackAreaElement );
					allItems.PipeRackAreas.addElement( aPipeRackArea );
				} //-------ObstacleBoxvf̉͂܂


				//---------------------------------------------------
				// PipeLinevf̃Xg擾
				list = root.getElementsByTagName("PipeLine");
System.out.println(" Num. of PipeLines = " + list.getLength() ) ;
				// PipeLinevf̐[v
				for (int i=0; i < list.getLength() ; i++) {
					Element PipeLineElement = (Element)list.item(i);
//					System.out.println("getting TagName: " + PipeElement.getTagName());
					PipeLine aPipeLine = new PipeLine() ; // 
					//-----XMLp[T"PipeLine"ƃxtꂽm[hElementlǂݍ
					aPipeLine.loadFromXMLelement( PipeLineElement );
					allItems.PipeLines.addElement( aPipeLine );
				} //----PipeLinevf̉͂܂
//System.out.println(" PipeHonsu = " + allItems.PipeLines.size() );
//System.out.println(" tyokei = " + allItems.PipeLines.elementAt(0).Pipes.elementAt(0).Diameter );
//System.out.println(" honsu = " + allItems.PipeLines.elementAt(0).Pipes.size() );


/**
				//-----PipeIuWFNg̎n_EI_ɑEquipment|C^RlN^No.ɒl蓖Ă
				if( tiePipesToEquipments() > 0 ){
					System.out.println("---------WARNING!! Start or end points of pipes do not match with the equipments.");
				}
*/

			}else{
				System.out.println("Cannot read this Root TagName! It should be <PipesAndEquipments>.");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	


	//----------------------------------------------------------------
	public String getXMLString( String comment ){
		StringBuffer strBuf = new StringBuffer() ;
//		System.out.println("flag");
		strBuf.append("<?xml version=\"1.0\" encoding=\"x-sjis\" standalone=\"yes\" ?> \n" );
		strBuf.append("<!DOCTYPE PlotPlan SYSTEM \"./PipesAndEquipments.dtd\"> \n" );
		strBuf.append("<!-- ").append( comment ).append(" --> \n" );
		strBuf.append("<PipesAndEquipments> \n" );

			//--- DesignSpace
			strBuf.append("\n<!-- DesignSpace --> \n" ) ;
			DesignSpace aDesignSpace = allItems.pid.DesignSpace.elementAt( 0 );
			strBuf.append( aDesignSpace.getXMLString() );

			//--- Aisle
			strBuf.append("\n<!-- Aisle(s) --> \n" ) ;
			for( int index = 0; index < allItems.AisleSpaces.size(); index++ ){
				AisleSpace anAisleSpace = allItems.AisleSpaces.elementAt( index );
				strBuf.append( anAisleSpace.getXMLString() );
			}

			//--- ObstacleBox
			strBuf.append("\n<!-- ObstacleBox(es) --> \n" ) ;
			for( int index = 0; index < allItems.pid.ObstacleBoxes.size(); index++ ){
				ObstacleBox anObstacleBox = allItems.pid.ObstacleBoxes.elementAt( index );
				strBuf.append( anObstacleBox.getXMLString() );
			}

			//--- ObstacleTriangle
			strBuf.append("\n<!-- ObstacleTriangle(s) --> \n" ) ;
			for( int index = 0; index < allItems.pid.ObstacleTriangles.size(); index++ ){
				ObstacleTriangle anObstacleTriangle = allItems.pid.ObstacleTriangles.elementAt( index );
				strBuf.append( anObstacleTriangle.getXMLString() );
			}

			//--- PipeRackArea
			strBuf.append("\n<!-- PipeRackArea(s) --> \n" ) ;
			for( int index = 0; index < allItems.PipeRackAreas.size(); index++ ){
				PipeRackArea aPipeRackArea = allItems.PipeRackAreas.elementAt( index );
				strBuf.append( aPipeRackArea.getXMLString() );
			}


			//--- PipeRoutes(s)
			strBuf.append("\n<!-- PipeRoutes(s) --> \n" ) ;
			for( int index = 0; index < allItems.PipeLines.size(); index++ ){
				PipeLine aPipeLine = allItems.PipeLines.elementAt( index );
				strBuf.append( aPipeLine.getXMLString() );
			}


		strBuf.append("</PipesAndEquipments> \n" );
		//-----------
		return( strBuf.toString() );
	}

	//------------------X3D̕𐶐
	public String getX3DString( String comment ){
		StringBuffer strBuf = new StringBuffer() ;
//		strBuf.append("<?xml version=\"1.0\" encoding=\"x-sjis\"?> \n" ); // {R[hƃG[œǂ߂Ȃ
//		strBuf.append("<?xml version=\"1.0\"?> \n" );
//		strBuf.append("<X3D>\n" );
//		strBuf.append("<Scene>\n" );
		strBuf.append("<!-- ").append( comment ).append(" --> \n" );
//		strBuf.append("<Background skyColor=\"0 1 1\" groundColor=\"0.5 0.5 0\" />\n");

			//--- Axes And Grid
			strBuf.append("\n<!-- DesignSpace --> \n" ) ;
			DesignSpace aDesignSpace = allItems.pid.DesignSpace.elementAt( 0 );
			strBuf.append( aDesignSpace.getDesignOfX3DString() );

			//--- DesignSpace
			strBuf.append("\n<!-- DesignSpace --> \n" ) ;
			strBuf.append( aDesignSpace.getX3DString() );

			//--- Aisle
			strBuf.append("\n<!-- Aisle(s) --> \n" ) ;
//			System.out.println("AisleSpaces.size() = " + allItems.AisleSpaces.size());
			for( int index = 0; index < allItems.AisleSpaces.size(); index++ ){
				AisleSpace anAisleSpace = allItems.AisleSpaces.elementAt( index );
				strBuf.append( anAisleSpace.getX3DString() );
			}


			//--- ObstacleBox
			strBuf.append("\n<!-- ObstacleBox(es) --> \n" ) ;
//			System.out.println("ObstacleBoxes.size() = " + allItems.pid.ObstacleBoxes.size());
			for( int index = 0; index < allItems.pid.ObstacleBoxes.size(); index++ ){
				ObstacleBox anObstacleBox = allItems.pid.ObstacleBoxes.elementAt( index );
				strBuf.append( anObstacleBox.getX3DString() );
			}

			//--- ObstacleTriangle
			strBuf.append("\n<!-- ObstacleTriangle(s) --> \n" ) ;
			for( int index = 0; index < allItems.pid.ObstacleTriangles.size(); index++ ){
				ObstacleTriangle anObstacleTriangle = allItems.pid.ObstacleTriangles.elementAt( index );
				strBuf.append( anObstacleTriangle.getX3DString() );
			}


			//--- PipeRackArea
			strBuf.append("\n<!-- PipeRackArea(s) --> \n" ) ;
			for( int index = 0; index < allItems.PipeRackAreas.size(); index++ ){
				PipeRackArea aPipeRackArea = allItems.PipeRackAreas.elementAt( index );
				strBuf.append( aPipeRackArea.getX3DString() );
			}


			//--- PipeRoutes(s)
			strBuf.append("\n<!-- PipeRoutes(s) --> \n" ) ;
			for( int index = 0; index < allItems.PipeLines.size(); index++ ){
				PipeLine aPipeLine = allItems.PipeLines.elementAt( index );
				strBuf.append( aPipeLine.getX3DString() );
			}


//		strBuf.append("</Scene> \n" );
//		strBuf.append("</X3D> \n" );
		//-----------
		return( strBuf.toString() );
	}





	//----------------------------------------------------------------
	// Dijkstra@ɂpCvzǒT
	//----------------------------------------------------------------
	public boolean routingByDijkstra( AllItems ai_org ){
		allItems = ai_org ; // n}
		//-----
		int maxNumOfInterfere = 1 ;
		int counter2 = 0;
		//--- allItems̒ɂpCvo
		Vector<PipeLine> OrgPipeLines = new Vector<PipeLine>(); 
		Vector<Pipe> OrgPipes = new Vector<Pipe>(); 
		Vector<Pipe> CheckPipes = new Vector<Pipe>() ;


		for( int index_p = 0; index_p < allItems.PipeLines.size() ; index_p++ ){
			PipeLine aPipeLine = allItems.PipeLines.elementAt( index_p );
			OrgPipeLines.addElement( aPipeLine );
			for( int index_pp = 0 ; index_pp < aPipeLine.Pipes.size(); index_pp++ ){
				Pipe aPipe = aPipeLine.Pipes.elementAt( index_pp );

			//--- X^[gƃS[n_ɏQݒu
				if(  aPipe.routingFlag == false ){
					// X^[gƃS[n_PipePieceNXŏQݒu
					aPipe.prepareDijkstra( allItems ) ;
//				}
				OrgPipes.addElement( aPipe );
				}
			}
		}

		// n_EI_EQƂ̊`FbN
		CheckPipes.addAll( OrgPipes ) ;
		for( int tmp = 0; tmp < CheckPipes.size() ; tmp++ ){
			Pipe aPipe = CheckPipes.elementAt( tmp );
			CheckPipes.remove( tmp ) ;
			for( int tmp1 = 0; tmp1 < aPipe.PipePieces.size() ; tmp1++ ){
				PipePiece aPipePiece = aPipe.PipePieces.elementAt( tmp1 );
				double d = aPipe.Diameter ;
				if( aPipePiece.x_OfStart >= aPipePiece.x_OfGoal ){ 
					x_max = aPipePiece.x_OfStart+d/2; x_min = aPipePiece.x_OfGoal-d/2;
				}else if( aPipePiece.x_OfStart < aPipePiece.x_OfGoal ){ 
					x_max = aPipePiece.x_OfGoal+d/2; x_min = aPipePiece.x_OfStart-d/2;
				} 
				if( aPipePiece.y_OfStart >= aPipePiece.y_OfGoal ){ 
					y_max = aPipePiece.y_OfStart+d/2; y_min = aPipePiece.y_OfGoal-d/2;
				}else if( aPipePiece.y_OfStart < aPipePiece.y_OfGoal ){ 
					y_max = aPipePiece.y_OfGoal+d/2; y_min = aPipePiece.y_OfStart-d/2;
				} 
				if( aPipePiece.z_OfStart >= aPipePiece.z_OfGoal ){ 
					z_max = aPipePiece.z_OfStart+d/2; z_min = aPipePiece.z_OfGoal-d/2;
				}else if( aPipePiece.z_OfStart < aPipePiece.z_OfGoal ){ 
					z_max = aPipePiece.z_OfGoal+d/2; z_min = aPipePiece.z_OfStart-d/2;
				} 

				if( judge( x_min, x_max, y_min, y_max, z_min, z_max, allItems ) == OBSTACLE ){
					System.out.println("Points are interfered with an Obstacle!! Check The Start And Goal Point Again.") ;
					System.out.println("Interfered points are ... ") ;
					System.out.println( aPipe.Specification ) ;
					System.out.print(" xOfStart = " + aPipePiece.x_OfStart ) ;
					System.out.print(" yOfStart = " + aPipePiece.y_OfStart ) ;
					System.out.println(" zOfStart = " + aPipePiece.z_OfStart ) ;
					System.out.print(" xOfGoal = " + aPipePiece.x_OfGoal ) ;
					System.out.print(" yOfGoal = " + aPipePiece.y_OfGoal ) ;
					System.out.println(" zOfGoal = " + aPipePiece.z_OfGoal ) ;
					return( false ) ;
				}

				for( int tmp2 = 0; tmp2 < CheckPipes.size() ; tmp2++ ){
					Pipe restPipe = CheckPipes.elementAt( tmp2 );
					double restD = restPipe.Diameter ;
					for( int tmp3 = 0; tmp3 < restPipe.PipePieces.size() ; tmp3++ ){
						PipePiece restPipePiece = restPipe.PipePieces.elementAt( tmp3 );
						if( restPipePiece.interfere( x_min, x_max, y_min, y_max, z_min, z_max, restD) ){
					System.out.println("Points are interfered with other Points!! Check The Start And Goal Point Again.") ;
					System.out.println("Interfered points are ... ") ;
					System.out.println( aPipe.Specification ) ;
					System.out.print(" xOfStart = " + aPipePiece.x_OfStart ) ;
					System.out.print(" yOfStart = " + aPipePiece.y_OfStart ) ;
					System.out.println(" zOfStart = " + aPipePiece.z_OfStart ) ;
					System.out.print(" xOfGoal = " + aPipePiece.x_OfGoal ) ;
					System.out.print(" yOfGoal = " + aPipePiece.y_OfGoal ) ;
					System.out.println(" zOfGoal = " + aPipePiece.z_OfGoal ) ;
					System.out.println(" And ") ;
					System.out.println( restPipe.Specification ) ;
					System.out.print(" xOfStart = " + restPipePiece.x_OfStart ) ;
					System.out.print(" yOfStart = " + restPipePiece.y_OfStart ) ;
					System.out.println(" zOfStart = " + restPipePiece.z_OfStart ) ;
					System.out.print(" xOfGoal = " + restPipePiece.x_OfGoal ) ;
					System.out.print(" yOfGoal = " + restPipePiece.y_OfGoal ) ;
					System.out.println(" zOfGoal = " + restPipePiece.z_OfGoal ) ;
							return( false ) ;
						}
					}
				}
			}
			CheckPipes.addElement( aPipe ) ;
		} 

		//pCv̖{2{ȏ̂Ƃaɕёւ
		if( OrgPipes.size() > 1){
System.out.println(" Num. of Pipes = " + OrgPipes.size() ) ;
			boolean substituteFlag = true ;
			while( substituteFlag == true ){
				substituteFlag = false ;
				for( int index_p = 0; index_p < OrgPipes.size()-1; index_p++ ){
					Pipe pipe1 = OrgPipes.elementAt( index_p );
					Pipe pipe2 = OrgPipes.elementAt( index_p+1 );
					if( pipe2.Diameter > pipe1.Diameter ){ // pCv̒a傫قOɎĂ
						OrgPipes.setElementAt( pipe2, index_p );
						OrgPipes.setElementAt( pipe1, index_p+1 );
						substituteFlag = true ;
					}else if( pipe2.Diameter == pipe1.Diameter ){ // pCv̒aꍇ̓_ɓւ
						if( MT19937.uniform() > 0.5 ){
							OrgPipes.setElementAt( pipe2, index_p );
							OrgPipes.setElementAt( pipe1, index_p+1 );
						}
					}
				}
			}
		}

		// pCvԂmF
System.out.println() ;
System.out.println( "OrderOfRouting: " );
		for( int indexA = 0; indexA < OrgPipes.size() ; indexA++ ){
			Pipe aPipe = OrgPipes.elementAt( indexA );
			int orderOfPipe = indexA + 1 ;
System.out.println( " " + orderOfPipe +  "  "  + aPipe.pid + ", Diameter = " + aPipe.Diameter ) ;
		}

		//------pCvzu
		while( maxNumOfInterfere > 0 ){
			maxNumOfInterfere = 0 ;

			for( int index_p = 0; index_p < OrgPipes.size() ; index_p++ ){
				Pipe aPipe = OrgPipes.elementAt( index_p );
				Pipes.addElement( aPipe );
				if( aPipe.routingFlag == false) {
					aPipe.PipePieces.removeAllElements() ; // X^[gES[n_ɂQ
System.out.println() ;
System.out.println("Now Applying Dijkstra method for " + aPipe.pid + "..." );
						if( aPipe.arrangeUsingDijkstra( allItems, aPipe  ) == true ){
System.out.println( "complete!");
							aPipe.routingFlag = true ;
							Pipes.addElement( aPipe ); continue;
						}else{
						//----Dijkstra@łpCvqȂꍇ
System.out.println("Failed! " );
							maxNumOfInterfere = -1 ;
							return( false ) ;
//							break;
						}
				}
			}
		}

		return( true );
	}





	//-----------------------
	// Ŏꂽbox̒ɏQEquipment,Pipe邩ǂA
	// 
	public short judge( double x_min, double x_max, double y_min, double y_max, double z_min, double z_max, AllItems allItems ){

		for( int index = 0; index < allItems.pid.ObstacleBoxes.size(); index++ ){
			ObstacleBox anObstacleBox = allItems.pid.ObstacleBoxes.elementAt( index );
			if( anObstacleBox.interfere( x_min, x_max, y_min, y_max, z_min, z_max ) ){
				return( OBSTACLE );
			}
		}


		for( int index = 0; index < allItems.pid.ObstacleTriangles.size(); index++ ){
			ObstacleTriangle anObstacleTriangle = allItems.pid.ObstacleTriangles.elementAt( index );
			if( anObstacleTriangle.interfere( x_min, x_max, y_min, y_max, z_min, z_max ) ){
				return( OBSTACLE );
			}
		}

/**
		for( int index = 0; index < Pipes.size() ; index++ ){
			Pipe aPipe = Pipes.elementAt( index );
			ObstacleBox ob = new ObstacleBox();
			ob.x_min = x_min ;  ob.x_max = x_max ; 
			ob.y_min = y_min ;  ob.y_max = y_max ; 
			ob.z_min = z_min ;  ob.z_max = z_max ; 
			if( aPipe.interfere( ob ) ){
				return( OBSTACLE );
			}
		}
*/
/**
		//--------ʘHǂ
		for( int index = 0; index < pid.ObstacleBoxes.size(); index++ ){
			Aisle anAisle = pid.Aisles.elementAt( index );
			if( anAisle.interfere( x_min, x_max, y_min, y_max, z_min, z_max ) ){
				return( AISLE );
			}
		}
*/
		//--------Ȃ
		return( 0 );
	}


	//----------------------------------------------------------------
	public static void main(String[] args) {
		//------
		if( args.length < 2 ){
			System.out.println("Usage:" );
			System.out.println("java PlotPlan <InputFileName> <OutputFileName>" );
			return ;
		}
		//---------------g̃CX^X𐶐
		AllItems ai = new AllItems();
		AutomaticRouting ap1 = new AutomaticRouting();
		ap1.loadFromXMLfile( args[0]  ,ai ); // PipesAndEquipmentsXMLt@CǍAaiɏǉ

		if(ap1.routingByDijkstra( ai ) == false){
			System.out.println("routing is failed!");
			return ;
		} 


		try{
			//-----t@CJăXg[o͐ƂiPrintWriterNXj
			PrintWriter LogStrm = new  PrintWriter( new FileOutputStream( args[1] +".x3d" ));
			LogStrm.println( "<?xml version='1.0' encoding='UTF-8'?>" );
			LogStrm.println( "<X3D>" );
			LogStrm.println( "<Scene>" );
			LogStrm.println("<Background skyColor=\"0 1 1\" groundColor=\"0.5 0.5 0\" />");
			LogStrm.println( ap1.getX3DString("MutationOperationTest") ); 
			LogStrm.println("</Transform>");	// <- _ړp
			LogStrm.println( "</Scene>" );
			LogStrm.println( "</X3D>" );
			LogStrm.flush() ;               // Ăł͂߂ďos@KrŌɂ
			LogStrm.close() ; 
		}catch( Exception IOException){ 
			System.out.println("File write error1: "+ args[1] +"." );
		}

		try{
			//-----t@CJăXg[o͐ƂiPrintWriterNXj
			PrintWriter LogStrm = new  PrintWriter( new FileOutputStream( args[1] +"m.xml" ));
			LogStrm.println( ap1.getXMLString("MutationOperationTest") ); 
			LogStrm.flush() ;               // Ăł͂߂ďos@KrŌɂ
			LogStrm.close() ; 
		}catch( Exception IOException){ 
			System.out.println("File write error2: "+ args[1] +"." );
		}

	}

}