// 

// 
// PipingDiagram.javaNXŎgp
// 
// 

// Bww@Hw@CmVXeHw
// ؑ@
// kimura@nams.kyushu-u.ac.jp
// http://sysplan.nams.kyushu-u.ac.jp/gen/index.html
//
//---------------------------------------------------
// 2013.02.05@Fǉ


import java.lang.Math ;
import java.io.* ;
import java.util.*;
// import MT19937 ; // double uniformRandomNumber  = MT19937.uniform() ; // 0-1̈l

import javax.xml.parsers.*;  // XMLp|T[֘ÃNX
import org.w3c.dom.*;        // XMLp|T[֘ÃNX


//-----------------------------------------

public class Pipe {

	//------ϐ
	AllItems allItems;
	public String Specification ;
	public String pid ;
	public double Diameter;

	public int StartConnectorNumber;
	public int GoalConnectorNumber;
	public double x_coordinateOfStartConnector;
	public double y_coordinateOfStartConnector;
	public double z_coordinateOfStartConnector;
	public double x_coordinateOfGoalConnector;
	public double y_coordinateOfGoalConnector;
	public double z_coordinateOfGoalConnector;
	public int x_axisOfStartConnector;
	public int y_axisOfStartConnector;
	public int z_axisOfStartConnector;
	public int x_axisOfGoalConnector;
	public int y_axisOfGoalConnector;
	public int z_axisOfGoalConnector;

	public double CostOfElbow;
	public double CostOfBend;
	public double RadiusOfElbow;
	public double RadiusOfBend;
	public double GapOfBend;
	public double StraightPartOfBend;
	public double AirPocketCoef ;

	public double red ;
	public double green ;
	public double blue ;


	public Vector<PipePiece> PipePieces;
	public Vector<Coordinate> Coordinates ;
	public Vector<Coordinate> CoordinatesPlus ;
	public Vector<Coordinate> CoordinatesMinus ;
	public Vector<ObstacleBox> CheckPipePieces ;

	public boolean routingFlag = false ;

	double x_min ;
	double y_min ;
	double z_min ;
	double x_max ;
	double y_max ;
	double z_max ;


	//-----------------------RXgN^
	Pipe(){
		Specification = "" ;
		PipePieces = new Vector<PipePiece>();
		Coordinates = new Vector<Coordinate>() ;
		CoordinatesPlus = new Vector<Coordinate>() ;
		CoordinatesMinus = new Vector<Coordinate>() ;
//		CheckPipePieces = new Vector<ObstacleBox>() ;
	}


	//--------------------W̒l_WʂŎľܓĊۂ߂
	public void roundCoordinate(){
		for( int index = 0; index < Coordinates.size(); index++ ){
			Coordinate aCoordinate = Coordinates.elementAt( index );
			aCoordinate.x = RoundDouble.round(7, aCoordinate.x );
			aCoordinate.y = RoundDouble.round(7, aCoordinate.y );
			aCoordinate.z = RoundDouble.round(7, aCoordinate.z );
		}
	}

	//----------------------------------------------
	// XMLp[T"Pipe"ƃxtꂽ
	// m[hElementlǂݍ
	//----------------------------------------------
	public void loadFromXMLelement( Element PipeElement ){
		// pid̒l擾
		pid = PipeElement.getAttribute("pid").trim();
//		System.out.println( "pid = " + pid );
		//----Specificationvf̃Xg擾
		NodeList list_Specification = PipeElement.getElementsByTagName("Specification");
		// ŏSpecificationǂݍ
		if( list_Specification.getLength() > 0 ){
			// Specificationvf擾
			Element element = (Element)list_Specification.item(0);
			// Specificationvf̍ŏ̎qm[hieLXgm[hj̒l擾
			Specification = element.getFirstChild().getNodeValue();
		}

		//----Diametervf擾
		NodeList DiameterList = PipeElement.getElementsByTagName("Diameter");
		if( DiameterList.getLength() > 0 ){
			// ŏDiametervf擾
			Element DiameterElement = (Element)DiameterList.item(0);
			// Diametervf̍ŏ̎qm[hieLXgm[hj̒l擾
			String str = DiameterElement.getFirstChild().getNodeValue();
			Diameter = Double.valueOf( str ).doubleValue() ;
//System.out.println("DiameterOfPipeInPipe.java = " + Diameter);
//System.out.println("Flag is " + routingFlag);
		}

		//----StartConnectingPointvf擾
		NodeList StartConnectingPointList = PipeElement.getElementsByTagName("StartConnectingPoint");
		if( StartConnectingPointList.getLength() > 0 ){
			// ŏStartConnectingPointvf擾
			Element element = (Element)StartConnectingPointList.item(0);

			// ConnectorNumbervf擾
			NodeList ConnectorNumberList = element.getElementsByTagName("ConnectorNumber");
			if( ConnectorNumberList.getLength() > 0 ){
				// ConnectorNumbervf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element ConnectorNumberElement = (Element)ConnectorNumberList.item(0);
				String str = ConnectorNumberElement.getFirstChild().getNodeValue();
				double tmp = Double.valueOf( str ).doubleValue() ;
				StartConnectorNumber = (int)tmp ;
//				StartConnectorNumber = Integer.valueOf( a ).intValue() ;
			}

			// Coordinatevf̎擾
			NodeList CoordinateList = element.getElementsByTagName("Coordinate");
			if( CoordinateList.getLength() > 0 ){
				// ŏCoordinateǂݍ
				Element CoordinateElement = (Element)CoordinateList.item(0);

				// x_coordinatevf擾
				NodeList x_coordinateList = CoordinateElement.getElementsByTagName("x_coordinate");
				if( x_coordinateList.getLength() > 0 ){
					// x_coordinatevf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element x_coordinateElement = (Element)x_coordinateList.item(0);
					String str = x_coordinateElement.getFirstChild().getNodeValue();
					double xtmp = Double.valueOf( str ).doubleValue() ;
					x_coordinateOfStartConnector = new Double( RoundDouble.round( 4, xtmp ) ) ;
				}

				// y_coordinatevf擾
				NodeList y_coordinateList = CoordinateElement.getElementsByTagName("y_coordinate");
				if( y_coordinateList.getLength() > 0 ){
					// y_coordinatevf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element y_coordinateElement = (Element)y_coordinateList.item(0);
					String str = y_coordinateElement.getFirstChild().getNodeValue();
					double ytmp = Double.valueOf( str ).doubleValue() ;
					y_coordinateOfStartConnector = new Double( RoundDouble.round( 4, ytmp ) ) ;
				}

				// z_coordinatevf擾
				NodeList z_coordinateList = CoordinateElement.getElementsByTagName("z_coordinate");
				if( z_coordinateList.getLength() > 0 ){
					// z_coordinatevf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element z_coordinateElement = (Element)z_coordinateList.item(0);
					String str = z_coordinateElement.getFirstChild().getNodeValue();
					double ztmp = Double.valueOf( str ).doubleValue() ;
					z_coordinateOfStartConnector = new Double( RoundDouble.round( 4, ztmp ) ) ;
				}

			}

			// Directionvf̎擾
			NodeList DirectionList = element.getElementsByTagName("Direction");
			if( DirectionList.getLength() > 0 ){
				// ŏCoordinateǂݍ
				Element DirectionElement = (Element)DirectionList.item(0);

				// x_axisvf擾
				NodeList x_axisList = DirectionElement.getElementsByTagName("x_axis");
				if( x_axisList.getLength() > 0 ){
					// x_axisvf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element x_axisElement = (Element)x_axisList.item(0);
					String str = x_axisElement.getFirstChild().getNodeValue();
					double tmp = Double.valueOf( str ).doubleValue() ;
					x_axisOfStartConnector = (int)tmp ;
//System.out.println( "x_axisOfStart load = " +  x_axisOfStartConnector) ;
//					x_axisOfStartConnector = Integer.valueOf( str ).intValue();
				}

				// y_axisvf擾
				NodeList y_axisList = DirectionElement.getElementsByTagName("y_axis");
				if( y_axisList.getLength() > 0 ){
					// y_axisvf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element y_axisElement = (Element)y_axisList.item(0);
					String str = y_axisElement.getFirstChild().getNodeValue();
					double tmp = Double.valueOf( str ).doubleValue() ;
					y_axisOfStartConnector = (int)tmp ;
//System.out.println( "y_axisOfStart load = " +  y_axisOfStartConnector) ;
//					y_axisOfStartConnector = Integer.valueOf( str ).intValue();
				}

				// z_axisvf擾
				NodeList z_axisList = DirectionElement.getElementsByTagName("z_axis");
				if( z_axisList.getLength() > 0 ){
					// z_axisvf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element z_axisElement = (Element)z_axisList.item(0);
					String str = z_axisElement.getFirstChild().getNodeValue();
					double tmp = Double.valueOf( str ).doubleValue() ;
					z_axisOfStartConnector = (int)tmp ;
//System.out.println( "z_axisOfStart load = " +  z_axisOfStartConnector) ;
//					z_axisOfStartConnector = Integer.valueOf( str ).intValue();
				}

			}

		}

		//----GoalConnectingPointvf擾
		NodeList GoalConnectingPointList = PipeElement.getElementsByTagName("GoalConnectingPoint");
		if( GoalConnectingPointList.getLength() > 0 ){
			// ŏGoalConnectingPointvf擾
			Element element = (Element)GoalConnectingPointList.item(0);

			// ConnectorNumbervf擾
			NodeList ConnectorNumberList = element.getElementsByTagName("ConnectorNumber");
			if( ConnectorNumberList.getLength() > 0 ){
				// ConnectorNumbervf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element ConnectorNumberElement = (Element)ConnectorNumberList.item(0);
				String str = ConnectorNumberElement.getFirstChild().getNodeValue();
				double tmp = Double.valueOf( str ).doubleValue() ;
				GoalConnectorNumber = (int)tmp ;
//				GoalConnectorNumber = Integer.valueOf( str ).intValue() ;
			}

			// Coordinatevf̎擾
			NodeList CoordinateList = element.getElementsByTagName("Coordinate");
			if( CoordinateList.getLength() > 0 ){
				// ŏCoordinateǂݍ
				Element CoordinateElement = (Element)CoordinateList.item(0);

				// x_coordinatevf擾
				NodeList x_coordinateList = CoordinateElement.getElementsByTagName("x_coordinate");
				if( x_coordinateList.getLength() > 0 ){
					// x_coordinatevf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element x_coordinateElement = (Element)x_coordinateList.item(0);
					String str = x_coordinateElement.getFirstChild().getNodeValue();
					double xtmp = Double.valueOf( str ).doubleValue() ;
					x_coordinateOfGoalConnector = new Double( RoundDouble.round( 4, xtmp ) ) ;

				}

				// y_coordinatevf擾
				NodeList y_coordinateList = CoordinateElement.getElementsByTagName("y_coordinate");
				if( y_coordinateList.getLength() > 0 ){
					// y_coordinatevf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element y_coordinateElement = (Element)y_coordinateList.item(0);
					String str = y_coordinateElement.getFirstChild().getNodeValue();
					double ytmp = Double.valueOf( str ).doubleValue() ;
					y_coordinateOfGoalConnector = new Double( RoundDouble.round( 4, ytmp ) ) ;
				}

				// z_coordinatevf擾
				NodeList z_coordinateList = CoordinateElement.getElementsByTagName("z_coordinate");
				if( z_coordinateList.getLength() > 0 ){
					// z_coordinatevf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element z_coordinateElement = (Element)z_coordinateList.item(0);
					String str = z_coordinateElement.getFirstChild().getNodeValue();
					double ztmp = Double.valueOf( str ).doubleValue() ;
					z_coordinateOfGoalConnector = new Double( RoundDouble.round( 4, ztmp ) ) ;
				}
//System.out.println( "coordinate load test " ) ;

			}

			// Directionvf̎擾
			NodeList DirectionList = element.getElementsByTagName("Direction");
			if( DirectionList.getLength() > 0 ){
				// ŏCoordinateǂݍ
				Element DirectionElement = (Element)DirectionList.item(0);

				// x_axisvf擾
				NodeList x_axisList = DirectionElement.getElementsByTagName("x_axis");
				if( x_axisList.getLength() > 0 ){
					// x_axisvf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element x_axisElement = (Element)x_axisList.item(0);
					String str = x_axisElement.getFirstChild().getNodeValue();
					double tmp = Double.valueOf( str ).doubleValue() ;
					x_axisOfGoalConnector = (int)tmp ;
//System.out.println( "x_axisOfGoal load = " +  x_axisOfGoalConnector) ;
//					x_axisOfGoalConnector = Integer.valueOf( str ).intValue();
				}

				// y_axisvf擾
				NodeList y_axisList = DirectionElement.getElementsByTagName("y_axis");
				if( y_axisList.getLength() > 0 ){
					// y_axisvf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element y_axisElement = (Element)y_axisList.item(0);
					String str = y_axisElement.getFirstChild().getNodeValue();
					double tmp = Double.valueOf( str ).doubleValue() ;
					y_axisOfGoalConnector = (int)tmp ;
//System.out.println( "y_axisOfGoal load = " +  y_axisOfGoalConnector) ;
//					y_axisOfGoalConnector = Integer.valueOf( str ).intValue();
				}

				// z_axisvf擾
				NodeList z_axisList = DirectionElement.getElementsByTagName("z_axis");
				if( z_axisList.getLength() > 0 ){
					// z_axisvf̍ŏ̎qm[hieLXgm[hj̒l擾
					Element z_axisElement = (Element)z_axisList.item(0);
					String str = z_axisElement.getFirstChild().getNodeValue();
					double tmp = Double.valueOf( str ).doubleValue() ;
					z_axisOfGoalConnector = (int)tmp ;
//System.out.println( "z_axisOfGoal load = " +  z_axisOfGoalConnector) ;
//					z_axisOfGoalConnector = Integer.valueOf( str ).intValue();
				}

			}
		}

		//----Constraintsvf擾
		NodeList ConstraintsList =PipeElement.getElementsByTagName("Constraints");
		if( ConstraintsList.getLength() > 0 ){
			// ŏConstraintsǂݍ
			Element element = (Element)ConstraintsList.item(0);

			// CostOfElbowvf擾
			NodeList CostOfElbowList = element.getElementsByTagName("CostOfElbow");
			if( CostOfElbowList.getLength() > 0 ){
				// CostOfElbowvf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element CostOfElbowElement = (Element)CostOfElbowList.item(0);
				String str = CostOfElbowElement.getFirstChild().getNodeValue();
				CostOfElbow = Double.valueOf( str ).doubleValue() ;
			}

			// CostOfBendvf擾
			NodeList CostOfBendList = element.getElementsByTagName("CostOfBend");
			if( CostOfBendList.getLength() > 0 ){
				// CostOfBendvf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element CostOfBendElement = (Element)CostOfBendList.item(0);
				String str = CostOfBendElement.getFirstChild().getNodeValue();
				CostOfBend = Double.valueOf( str ).doubleValue() ;
			}

			// RadiusOfElbowvf擾
			NodeList RadiusOfElbowList = element.getElementsByTagName("RadiusOfElbow");
			if( RadiusOfElbowList.getLength() > 0 ){
				// GapOfBendvf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element RadiusOfElbowElement = (Element)RadiusOfElbowList.item(0);
				String str = RadiusOfElbowElement.getFirstChild().getNodeValue();
				RadiusOfElbow = Double.valueOf( str ).doubleValue() ;
			}

			// RadiusOfBendvf擾
			NodeList RadiusOfBendList = element.getElementsByTagName("RadiusOfBend");
			if( RadiusOfBendList.getLength() > 0 ){
				// RadiusOfBendvf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element RadiusOfBendElement = (Element)RadiusOfBendList.item(0);
				String str = RadiusOfBendElement.getFirstChild().getNodeValue();
				RadiusOfBend = Double.valueOf( str ).doubleValue() ;
			}

			// GapOfBendvf擾
			NodeList GapOfBendList = element.getElementsByTagName("GapOfBend");
			if( GapOfBendList.getLength() > 0 ){
				// GapOfBendvf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element GapOfBendElement = (Element)GapOfBendList.item(0);
				String str = GapOfBendElement.getFirstChild().getNodeValue();
				GapOfBend = Double.valueOf( str ).doubleValue() ;
			}

			// StraightPartOfBendvf擾
			NodeList StraightPartOfBendList = element.getElementsByTagName("StraightPartOfBend");
			if( StraightPartOfBendList.getLength() > 0 ){
				// StraightPartOfBendvf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element StraightPartOfBendElement = (Element)StraightPartOfBendList.item(0);
				String str = StraightPartOfBendElement.getFirstChild().getNodeValue();
				StraightPartOfBend = Double.valueOf( str ).doubleValue() ;
			}

			// AirPocketCoefvf擾
			AirPocketCoef = 0 ;
			NodeList AirPocketCoefList = element.getElementsByTagName("AirPocketCoef");
			if( AirPocketCoefList.getLength() > 0 ){
				// AirPocketCoefvf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element AirPocketCoefElement = (Element)AirPocketCoefList.item(0);
				String str = AirPocketCoefElement.getFirstChild().getNodeValue();
				AirPocketCoef = Double.valueOf( str ).doubleValue() ;
			}

		}

		//----Colorvf擾
		red = 0; green = 0; blue = 0;
		NodeList ColorList =PipeElement.getElementsByTagName("Color");
		if( ColorList.getLength() > 0 ){
			// ŏConstraintsǂݍ
			Element element = (Element)ColorList.item(0);

			// Redvf擾
			NodeList RedList = element.getElementsByTagName("Red");
			if( RedList.getLength() > 0 ){
				// RedListvf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element RedElement = (Element)RedList.item(0);
				String str = RedElement.getFirstChild().getNodeValue();
				red = Double.valueOf( str ).doubleValue() ;
			}

			// Greenvf擾
			NodeList GreenList = element.getElementsByTagName("Green");
			if( GreenList.getLength() > 0 ){
				// GreenListvf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element GreenElement = (Element)GreenList.item(0);
				String str = GreenElement.getFirstChild().getNodeValue();
				green = Double.valueOf( str ).doubleValue() ;
			}

			// Bluevf擾
			NodeList BlueList = element.getElementsByTagName("Blue");
			if( BlueList.getLength() > 0 ){
				// BlueListvf̍ŏ̎qm[hieLXgm[hj̒l擾
				Element BlueElement = (Element)BlueList.item(0);
				String str = BlueElement.getFirstChild().getNodeValue();
				blue = Double.valueOf( str ).doubleValue() ;
			}

		}


		//----PipePiecevf擾
		NodeList PipePieceList = PipeElement.getElementsByTagName("PipePiece");
		// PipePiecevf̐[v
		for (int i=0; i < PipePieceList.getLength() ; i++) {
			PipePiece aPipePiece = new PipePiece() ; // 
			Element PipePieceElement = (Element)PipePieceList.item(i);
			//-----XMLp[T"Pipe"ƃxtꂽm[hElementlǂݍ
			aPipePiece.loadFromXMLelement( PipePieceElement );
			PipePieces.addElement( aPipePiece );
		}
		if( PipePieces.size() > 0 ){
			routingFlag = true ;
		}
	}



	//-----------------------------------------------
	// ڐG̔ ̔ƐڐGĂtrueԂ
/**
	//-----------------------------------------------
	public boolean interfere( double ix_min, double ix_max, double iy_min, double iy_max, double iz_min, double iz_max ){ 
		if( ix_min >= x_max ){ return( false );}
		if( ix_max <= x_min ){ return( false );}
		if( iy_min >= y_max ){ return( false );}
		if( iy_max <= y_min ){ return( false );}
		if( iz_min >= z_max ){ return( false );}
		if( iz_max <= z_min ){ return( false );}
		return( true );
	}
*/

	//----------------------------------------------
	public String getXMLString(){
		StringBuffer strBuf = new StringBuffer() ;
		if( pid == null ){
			strBuf.append("<Pipe> \n") ;
		}else{
			strBuf.append("<Pipe pid=\"" ).append( pid ).append("\" > \n" );
		}
		if( Specification.length() > 0 ){
			strBuf.append("<Specification>").append( Specification ).append("</Specification> \n") ;
		}
		strBuf.append("<Diameter>  ").append( Diameter ).append("  </Diameter> \n") ;
		strBuf.append("<StartConnectingPoint> \n") ;
		strBuf.append("<ConnectorNumber>  ").append( StartConnectorNumber).append("  </ConnectorNumber> \n") ;
		strBuf.append("<Coordinate> \n") ;
		strBuf.append("<x_coordinate>  ").append( x_coordinateOfStartConnector ).append("  </x_coordinate>  \n") ;
		strBuf.append("<y_coordinate>  ").append( y_coordinateOfStartConnector ).append("  </y_coordinate>  \n") ;
		strBuf.append("<z_coordinate>  ").append( z_coordinateOfStartConnector ).append("  </z_coordinate>  \n") ;
		strBuf.append("</Coordinate> \n") ;
		strBuf.append("<Direction> \n") ;
		strBuf.append("<x_axis>  ").append( x_axisOfStartConnector ).append("  </x_axis>  \n") ;
		strBuf.append("<y_axis>  ").append( y_axisOfStartConnector ).append("  </y_axis>  \n") ;
		strBuf.append("<z_axis>  ").append( z_axisOfStartConnector ).append("  </z_axis>  \n") ;
		strBuf.append("</Direction> \n") ;
		strBuf.append("</StartConnectingPoint> \n") ;
		strBuf.append("<GoalConnectingPoint> \n") ;
		strBuf.append("<ConnectorNumber>  ").append( GoalConnectorNumber).append("  </ConnectorNumber> \n") ;
		strBuf.append("<Coordinate> \n") ;
		strBuf.append("<x_coordinate>  ").append( x_coordinateOfGoalConnector ).append("  </x_coordinate>  \n") ;
		strBuf.append("<y_coordinate>  ").append( y_coordinateOfGoalConnector ).append("  </y_coordinate>  \n") ;
		strBuf.append("<z_coordinate>  ").append( z_coordinateOfGoalConnector ).append("  </z_coordinate>  \n") ;
		strBuf.append("</Coordinate> \n") ;
		strBuf.append("<Direction> \n") ;
		strBuf.append("<x_axis>  ").append( x_axisOfGoalConnector ).append("  </x_axis>  \n") ;
		strBuf.append("<y_axis>  ").append( y_axisOfGoalConnector ).append("  </y_axis>  \n") ;
		strBuf.append("<z_axis>  ").append( z_axisOfGoalConnector ).append("  </z_axis>  \n") ;
		strBuf.append("</Direction> \n") ;
		strBuf.append("</GoalConnectingPoint> \n") ;
		strBuf.append("<Constraints> \n") ;
		strBuf.append("<CostOfElbow>  ").append( CostOfElbow ).append("  </CostOfElbow>  \n") ;
		strBuf.append("<CostOfBend>  ").append( CostOfBend ).append("  </CostOfBend>  \n") ;
		strBuf.append("<RadiusOfElbow>  ").append( RadiusOfElbow ).append("  </RadiusOfElbow>  \n") ;
		strBuf.append("<RadiusOfBend>  ").append( RadiusOfBend ).append("  </RadiusOfBend>  \n") ;
		strBuf.append("<GapOfBend>  ").append( GapOfBend ).append("  </GapOfBend>  \n") ;
		strBuf.append("<StraightPartOfBend>  ").append( StraightPartOfBend ).append("  </StraightPartOfBend>  \n") ;
		strBuf.append("<AirPocketCoef>  ").append( AirPocketCoef ).append("  </AirPocketCoef>  \n") ;
		strBuf.append("</Constraints> \n") ;
		strBuf.append("<Color> \n") ;
		strBuf.append("<Red>  ").append( red ).append("  </Red>  \n") ;
		strBuf.append("<Green>  ").append( green ).append("  </Green>  \n") ;
		strBuf.append("<Blue>  ").append( blue ).append("  </Blue>  \n") ;
		strBuf.append("</Color> \n") ;

		//--- PipePieces
		for( int index = 0; index < PipePieces.size(); index++ ){
			PipePiece aPipePiece = PipePieces.elementAt( index );
			strBuf.append( aPipePiece.getXMLString() );
		}
		strBuf.append("</Pipe> \n" );


		return( strBuf.toString() );
	}
	//----------------------------------------------
	public String getX3DString(){
		StringBuffer strBuf = new StringBuffer() ;

		//-----------------n_΋ŕ\
		strBuf.append("<Transform translation=\"" );
		strBuf.append( x_coordinateOfStartConnector ).append(" ") ;
		strBuf.append( z_coordinateOfStartConnector ).append(" ") ;
		strBuf.append( y_coordinateOfStartConnector ).append("\">\n") ;
		strBuf.append("<Shape> \n" );
		strBuf.append("<Sphere radius=\"") ;
		strBuf.append( Diameter/4 ).append("\"/>\n") ;
		strBuf.append("<Appearance>\n");
		strBuf.append("<Material diffuseColor = '0 1 0' />\n");
		strBuf.append("</Appearance>\n");
		strBuf.append("</Shape> \n" );
		strBuf.append("</Transform>\n" );
		//-----------------I_Ԃ̋ŕ\
		strBuf.append("<Transform translation=\"" );
		strBuf.append( x_coordinateOfGoalConnector ).append(" ") ;
		strBuf.append( z_coordinateOfGoalConnector ).append(" ") ;
		strBuf.append( y_coordinateOfGoalConnector ).append("\">\n") ;
		strBuf.append("<Shape> \n" );
		strBuf.append("<Sphere radius=\"") ;
		strBuf.append( Diameter/4 ).append("\"/>\n") ;
		strBuf.append("<Appearance>\n");
		strBuf.append("<Material diffuseColor = '1 0 0' />\n");
		strBuf.append("</Appearance>\n");
		strBuf.append("</Shape> \n" );
		strBuf.append("</Transform>\n" );

		//--- PipePieces
		for( int index = 0; index < PipePieces.size(); index++ ){
			PipePiece aPipePiece = PipePieces.elementAt( index );
//			strBuf.append("<Anchor url = '\"").append( getURLname() ).append("\"'>\n");
			strBuf.append( aPipePiece.getX3DString( Diameter, RadiusOfBend, GapOfBend, StraightPartOfBend, red, green, blue ) );
//			strBuf.append("</Anchor>\n" ); // ߍ݂InstantPlayerł͌Ȃ͗l
		}

		//--- G{ɋ̂zu
		if( red==0 && green==0 && blue==0 ){
			red = 0.8 ;
			green = 0.8 ;
			blue = 0 ;
		}
		if( PipePieces.size() > 1){
			for( int index = 0; index < PipePieces.size()-1; index++  ){
				PipePiece aPipePiece = PipePieces.elementAt( index );
				if( (aPipePiece.x_OfGoal == aPipePiece.x_OfStart) &&
				    (aPipePiece.y_OfGoal == aPipePiece.y_OfStart) &&
				    (aPipePiece.z_OfGoal == aPipePiece.z_OfStart) &&
				    (index == 0) ){
				}else{
					strBuf.append("<Transform translation=\"" );
					strBuf.append( aPipePiece.x_OfGoal ).append(" ") ;
					strBuf.append( aPipePiece.z_OfGoal ).append(" ") ;
					strBuf.append( aPipePiece.y_OfGoal ).append("\">\n") ;
					strBuf.append("<Shape> \n" );
					strBuf.append("<Sphere radius=\"") ;
					strBuf.append( Diameter/2 ).append("\"/>\n") ;
					strBuf.append("<Appearance>\n");
					strBuf.append("<Material diffuseColor = \"" );
					strBuf.append( red ).append(" ") ;
					strBuf.append( green ).append(" ") ;
					strBuf.append( blue ).append("\"/>\n") ;
					strBuf.append("</Appearance>\n");
					strBuf.append("</Shape> \n" );
					strBuf.append("</Transform>\n" );
				}
			}
		}
		return( strBuf.toString() );
	}

	//------HTML̃t@C̐
	public String getURLname(){
		StringBuffer strBuf = new StringBuffer() ;
		strBuf.append("pipeTest").append(".txt");
//		strBuf.append("pipe").append( pipes.get(i).NumOfPipe).append(".txt");
		return( strBuf.toString() );
	}

	//-------------------------------------------------------------
	// _CNXg@ŃpCvOɃX^[gS[ɏQ(PipePiece)zu
	//-------------------------------------------------------------
	public boolean prepareDijkstra( AllItems allItems ){

		boolean PointFlag = true ;

		//--------startPointsecondPoint
		Coordinate startPoint = new Coordinate() ; 
		startPoint.x = x_coordinateOfStartConnector ;
		startPoint.y = y_coordinateOfStartConnector ;
		startPoint.z = z_coordinateOfStartConnector ;

		Coordinate startPointDirection = new Coordinate() ; 
		startPointDirection.x = x_axisOfStartConnector ;
		startPointDirection.y = y_axisOfStartConnector ;
		startPointDirection.z = z_axisOfStartConnector ;

		double shortestLength = new Double( RoundDouble.round( 3, 1.0 * Diameter )) ; // pCva x 1.0
		Coordinate secondPoint = new Coordinate() ; 
		secondPoint.x = x_coordinateOfStartConnector ;
		secondPoint.y = y_coordinateOfStartConnector ;
		secondPoint.z = z_coordinateOfStartConnector ;
		double x_tmp =  new Double( RoundDouble.round( 3, shortestLength * x_axisOfStartConnector ) ) ;
		double y_tmp =  new Double( RoundDouble.round( 3, shortestLength * y_axisOfStartConnector ) ) ;
		double z_tmp =  new Double( RoundDouble.round( 3, shortestLength * z_axisOfStartConnector ) ) ;

		secondPoint.x += x_tmp ;
		secondPoint.y += y_tmp ;
		secondPoint.z += z_tmp ;

//System.out.println("prepareDijkstra");


		//--------thirdPointendPoint
		Coordinate endPoint   = new Coordinate() ; 
		endPoint.x = x_coordinateOfGoalConnector ;
		endPoint.y = y_coordinateOfGoalConnector ;
		endPoint.z = z_coordinateOfGoalConnector ;

		Coordinate endPointDirection = new Coordinate() ; 
		endPointDirection.x = x_axisOfGoalConnector ;
		endPointDirection.y = y_axisOfGoalConnector ;
		endPointDirection.z = z_axisOfGoalConnector ;

		Coordinate thirdPoint = new Coordinate() ; 
		thirdPoint.x = x_coordinateOfGoalConnector ;
		thirdPoint.y = y_coordinateOfGoalConnector ;
		thirdPoint.z = z_coordinateOfGoalConnector ;
		x_tmp =  new Double( RoundDouble.round( 3, shortestLength * x_axisOfGoalConnector ) ) ;
		y_tmp =  new Double( RoundDouble.round( 3, shortestLength * y_axisOfGoalConnector ) ) ;
		z_tmp =  new Double( RoundDouble.round( 3, shortestLength * z_axisOfGoalConnector ) ) ;
		thirdPoint.x += x_tmp ;
		thirdPoint.y += y_tmp ;
		thirdPoint.z += z_tmp ;

		PipePiece tmpPipePiece1 = new PipePiece() ;
		tmpPipePiece1.x_OfStart = startPoint.x ;
		tmpPipePiece1.y_OfStart = startPoint.y ;
		tmpPipePiece1.z_OfStart = startPoint.z ;
		tmpPipePiece1.x_OfGoal = secondPoint.x ;
		tmpPipePiece1.y_OfGoal = secondPoint.y ;
		tmpPipePiece1.z_OfGoal = secondPoint.z ;

		PipePiece tmpPipePiece2 = new PipePiece() ;
		tmpPipePiece2.x_OfStart = endPoint.x ;
		tmpPipePiece2.y_OfStart = endPoint.y ;
		tmpPipePiece2.z_OfStart = endPoint.z ;
		tmpPipePiece2.x_OfGoal = thirdPoint.x ;
		tmpPipePiece2.y_OfGoal = thirdPoint.y ;
		tmpPipePiece2.z_OfGoal = thirdPoint.z ;

/**
		if( startPoint.x >= secondPoint.x ){
			x_max = startPoint.x+Diameter/2; x_min = secondPoint.x-Diameter/2;
		}else if( startPoint.x < secondPoint.x ){ 
			x_max = secondPoint.x+Diameter/2; x_min = startPoint.x-Diameter/2;
		} 
		if( startPoint.y >= secondPoint.y ){
			y_max = startPoint.y+Diameter/2; y_min = secondPoint.y-Diameter/2;
		}else if( startPoint.y < secondPoint.y ){
			y_max = secondPoint.y+Diameter/2; y_min = startPoint.y-Diameter/2;
		} 
		if( startPoint.z >= secondPoint.z ){
			z_max = startPoint.z+Diameter/2; z_min = secondPoint.z-Diameter/2;
		}else if( startPoint.z < secondPoint.z ){
			z_max = secondPoint.z+Diameter/2; z_min = startPoint.z-Diameter/2;
		} 
		if( judge( x_min, x_max, y_min, y_max, z_min, z_max, allItems ) == OBSTACLE ){
			System.out.println("Start Point are interfered with obstacle!! Check The Start And Goal Point Again.") ;
			PointFlag = false ;
System.out.println( "Interfered StartPoint is of " + pid ) ;
			return( false ) ;
		}


		if( thirdPoint.x >= endPoint.x ){
			x_max = thirdPoint.x+Diameter/2; x_min = endPoint.x-Diameter/2;
		}else if( thirdPoint.x < endPoint.x ){ 
			x_max = endPoint.x+Diameter/2; x_min = thirdPoint.x-Diameter/2;
		} 
		if( thirdPoint.y >= endPoint.y ){
			y_max = thirdPoint.y+Diameter/2; y_min = endPoint.y-Diameter/2;
		}else if( thirdPoint.y < endPoint.y ){
			y_max = endPoint.y+Diameter/2; y_min = thirdPoint.y-Diameter/2;
		} 
		if( thirdPoint.z >= endPoint.z ){
			z_max = thirdPoint.z+Diameter/2; z_min = endPoint.z-Diameter/2;
		}else if( thirdPoint.z < endPoint.z ){
			z_max = endPoint.z+Diameter/2; z_min = thirdPoint.z-Diameter/2;
		} 
		if( judge( x_min, x_max, y_min, y_max, z_min, z_max, allItems ) == OBSTACLE ){
			System.out.println("Goal Point are interfered with obstacle!! Check The Start And Goal Point Again.") ;
			PointFlag = false ;
System.out.println( "Interfered GoalPoint is of " + pid ) ;
			return( false ) ;
		}
*/


		PipePieces.addElement( tmpPipePiece1 );
		PipePieces.addElement( tmpPipePiece2 );

// StartPointGoalPoint\ fobNp
		try{
			//-----t@CJăXg[o͐ƂiPrintWriterNXj
			PrintWriter LogStrm = new  PrintWriter( new FileOutputStream( "StartAndGoalPoints.x3d" ));
			LogStrm.println( "<?xml version=\"1.0\"?>" );
			LogStrm.println( "<X3D>" );
			LogStrm.println( "<Scene>" );
			LogStrm.println("<Background skyColor=\"0 1 1\" groundColor=\"0.5 0.5 0\" />");
			LogStrm.println( allItems.getX3DString("routingTest") ); 
			LogStrm.println("</Transform>");	// <- _ړp
			LogStrm.println( "</Scene>" );
			LogStrm.println( "</X3D>" );
			LogStrm.flush() ;               // Ăł͂߂ďos@KrŌɂ
			LogStrm.close() ; 
		}catch( Exception IOException){ 
			System.out.println("File write error in StartAndGoals: " );
		}


		if( PointFlag == false ){
			return( false );
		}
		return( true ) ;
	}



	//-------------------------------------------------------------
	// _CNXg@ɂăpCv
	//-------------------------------------------------------------
	public boolean arrangeUsingDijkstra( AllItems allItems, Pipe aPipe ){
//System.out.println("In pipe.arrangeUsingDijkstra");
//System.out.println( pid ) ;
		PipingDiagram pid = new PipingDiagram() ;
		pid = allItems.pid ;

		Coordinate startPoint = new Coordinate() ; 
		startPoint.x = x_coordinateOfStartConnector ;
		startPoint.y = y_coordinateOfStartConnector ;
		startPoint.z = z_coordinateOfStartConnector ;

		Coordinate startPointDirection = new Coordinate() ; 
		startPointDirection.x = x_axisOfStartConnector ;
		startPointDirection.y = y_axisOfStartConnector ;
		startPointDirection.z = z_axisOfStartConnector ;

//System.out.println("xStart = " + startPoint.x);
//System.out.println("yStart = " + startPoint.y);
//System.out.println("zStart = " + startPoint.z);





//System.out.println("xStartDirection = " + startPointDirection.x);
//System.out.println("yStartDirection = " + startPointDirection.y);
//System.out.println("zStartDirection = " + startPointDirection.z);


		//--------thirdPointendpoint
		Coordinate endPoint   = new Coordinate() ; 
		endPoint.x = x_coordinateOfGoalConnector ;
		endPoint.y = y_coordinateOfGoalConnector ;
		endPoint.z = z_coordinateOfGoalConnector ;

		Coordinate endPointDirection = new Coordinate() ; 
		endPointDirection.x = x_axisOfGoalConnector ;
		endPointDirection.y = y_axisOfGoalConnector ;
		endPointDirection.z = z_axisOfGoalConnector ;


//System.out.println("xGoal = " + endPoint.x);
//System.out.println("yGoal = " + endPoint.y);
//System.out.println("zGoal = " + endPoint.z);


//System.out.println("xGoalDirection = " + endPointDirection.x);
//System.out.println("yGoalDirection = " + endPointDirection.y);
//System.out.println("zGoalDirection = " + endPointDirection.z);

//System.out.println("In pipe.arrangeUsingDijkstra2");
 


//System.out.println("In pipe.arrangeUsingDijkstra3");

		//------Dijkstra@Kp
		double costE = CostOfElbow ;
		double costB = CostOfBend ;
		double radiusB = RadiusOfBend ;
		double gapB = GapOfBend ;
		double stpartB = StraightPartOfBend ;
		double ApocketC = AirPocketCoef ;
		if( ApocketC == 0 ){
			ApocketC = 1 ;
			System.out.println( "AirPocketCoef1ɐݒ肳܂" );
		}

//System.out.println("CostOfElbow = " + costE);
//System.out.println("In pipe.arrangeUsingDijkstra4");

		DijkstraForPiping dfp0 = new DijkstraForPiping( startPoint, startPointDirection, endPoint, endPointDirection, Diameter, 
							       costE, costB, radiusB, gapB, stpartB, ApocketC, pid, allItems );

		DijkstraForPipingDzPlus dfp1 = new DijkstraForPipingDzPlus( startPoint, startPointDirection, endPoint, endPointDirection, Diameter, 
							       costE, costB, radiusB, gapB, stpartB, ApocketC, pid, allItems );

		DijkstraForPipingDzMinus dfp2 = new DijkstraForPipingDzMinus( startPoint, startPointDirection, endPoint, endPointDirection, Diameter, 
							       costE, costB, radiusB, gapB, stpartB, ApocketC, pid, allItems );


		boolean arrangedSuccessfully0 = false ;
		boolean arrangedSuccessfully1 = false ;
		boolean arrangedSuccessfully2 = false ;

		boolean snakeCheck0 = false ;
		boolean snakeCheck1 = false ;
		boolean snakeCheck2 = false ;


		if( ((startPoint.z - endPoint.z) >= 0) &&
		    (startPointDirection.z <= 0 && endPointDirection.z >= 0) ){

			arrangedSuccessfully1 = dfp1.search() ; // _CNXg@ŃS[X^[g֓BŏRXg̃pXT

			//---[g𐔎ŕ\(fobNp)--- 
			if( arrangedSuccessfully1 == false ){
				arrangedSuccessfully0 = dfp0.search() ;
				if( arrangedSuccessfully0 == false ){
					return( false );
				}
				// fobNp[g\
				Coordinates = dfp0.getPathCoordinatesForCheck() ;
//				Coordinates = dfp0.getPathCoordinates() ;

				snakeCheck0 = isConsistent2() ;
				if( snakeCheck0 == false ){
					System.out.println( " 		Snake hides in your routes  1 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ") ;
				}

			}else if( arrangedSuccessfully1 == true ){
//				dfp1.getPathCoordinatesForCheck();
				Coordinates = dfp1.getPathCoordinatesForCheck() ;
//				Coordinates = dfp1.getPathCoordinates() ;
				snakeCheck1 = isConsistent2() ;
				if( snakeCheck1 == false ){
					System.out.println( " 		Snake hides in your routes  2 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ") ;
//					arrangedSuccessfully1 = false ; 
					//--ă[eBO
					arrangedSuccessfully0 = dfp0.search() ;
					if( arrangedSuccessfully0 == false ){
						return( false );
					}
					// fobNp[g\
					Coordinates = dfp0.getPathCoordinatesForCheck() ;
//					Coordinates = dfp0.getPathCoordinates() ;
					snakeCheck0 = isConsistent2() ;
					if( snakeCheck0 == false ){
						System.out.println( " 		Snake hides in your routes  3 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ") ;
					}
				}
			}
		}else if( ((startPoint.z - endPoint.z) < 0) &&
 			  (startPointDirection.z >= 0 && endPointDirection.z <= 0) ){

			arrangedSuccessfully2 = dfp2.search() ; // _CNXg@ŃS[X^[g֓BŏRXg̃pXT

			//---[g𐔎ŕ\(fobNp)--- 
			if( arrangedSuccessfully2 == false ){
				arrangedSuccessfully0 = dfp0.search() ;
				if( arrangedSuccessfully0 == false ){
					return( false );
				}
				// fobNp[g\
				Coordinates = dfp0.getPathCoordinatesForCheck() ;
//				Coordinates = dfp0.getPathCoordinates() ;
				snakeCheck0 = isConsistent2() ;
				if( snakeCheck0 == false ){
					System.out.println( " 		Snake hides in your routes  4 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ") ;
				}

			}else if( arrangedSuccessfully2 == true){
				Coordinates = dfp2.getPathCoordinatesForCheck() ;
//				Coordinates = dfp2.getPathCoordinates() ;
				snakeCheck2 = isConsistent2() ;
				if( snakeCheck2 == false ){
					System.out.println( " 		Snake hides in your routes  5 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ") ;
//					arrangedSuccessfully2 = false ; 
					//--ă[eBO
					arrangedSuccessfully0 = dfp0.search() ;
					if( arrangedSuccessfully0 == false ){
						return( false );
					}
					// fobNp[g\
					Coordinates = dfp0.getPathCoordinatesForCheck() ;
//					Coordinates = dfp0.getPathCoordinates() ;
					snakeCheck0 = isConsistent2() ;
					if( snakeCheck0 == false ){
						System.out.println( " 		Snake hides in your routes  6 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ") ;
					}
				}
			}
		}else{
			arrangedSuccessfully0 = dfp0.search() ; // _CNXg@ŃS[X^[g֓BŏRXg̃pXT

			//---[g𐔎ŕ\(fobNp)--- 
			if( arrangedSuccessfully0 == true ){

				Coordinates = dfp0.getPathCoordinatesForCheck() ;
//				Coordinates = dfp0.getPathCoordinates() ;
				snakeCheck0 = isConsistent2() ;
				if( snakeCheck0 == false ){
					System.out.println( " 		Snake hides in your routes  7 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! ") ;
				}

			}else{
				return( false ) ;
			}
		}

/**
//ForSimulation
///////////////////////////////////////////////////////
			arrangedSuccessfully0 = dfp0.search() ;
			if( arrangedSuccessfully0 == false ){
				return( false );
			}
			// fobNp[g\
			Coordinates = dfp0.getPathCoordinatesForCheck() ;
//			Coordinates = dfp0.getPathCoordinates() ;
///////////////////////////////////////////////////////
*/
		if((arrangedSuccessfully1 == true) && (snakeCheck1 == true)){
			Coordinates = dfp1.getPathCoordinates() ; // X^[gS[܂ł̌oH̍W𓾂
		}else if((arrangedSuccessfully2 == true) && (snakeCheck2 == true)){
			Coordinates = dfp2.getPathCoordinates() ; // X^[gS[܂ł̌oH̍W𓾂
		}else if(arrangedSuccessfully0 == true){
			Coordinates = dfp0.getPathCoordinates() ; // X^[gS[܂ł̌oH̍W𓾂
		}

		for( int index = 0; index < Coordinates.size()-1; index++ ){
			Coordinate coordinate1 = Coordinates.elementAt( index );
			Coordinate coordinate2 = Coordinates.elementAt( index+1 );
			PipePiece aPipePiece = new PipePiece() ;
			aPipePiece.makePipePiece( coordinate1, coordinate2 );
			PipePieces.addElement( aPipePiece );
//	System.out.println( "NumOfPipePiece = " + PipePieces.size() );
		}
		Coordinates.add( 0, startPoint ) ; // n_̍W
		Coordinates.add( endPoint ) ;      // I_̍W

		if( (arrangedSuccessfully0 == false )&&(arrangedSuccessfully1 == false )&&(arrangedSuccessfully2 == false ) ){
			return( false ) ;
		}

// 1{тProcess.xmlro fobNp
		try{
			//-----t@CJăXg[o͐ƂiPrintWriterNXj
			PrintWriter LogStrm = new  PrintWriter( new FileOutputStream( "Process.x3d" ));
			LogStrm.println( "<?xml version=\"1.0\"?>" );
			LogStrm.println( "<X3D>" );
			LogStrm.println( "<Scene>" );
			LogStrm.println("<Background skyColor=\"0 1 1\" groundColor=\"0.5 0.5 0\" />");
			if( (arrangedSuccessfully1 == true) && (snakeCheck1 == true)){
				LogStrm.println( dfp1.getX3DString("routingTest") ); 
			}else if( (arrangedSuccessfully2 == true) && (snakeCheck2 == true) ){
				LogStrm.println( dfp2.getX3DString("routingTest") ); 
			}else if( arrangedSuccessfully0 == true ){
				LogStrm.println( dfp0.getX3DString("routingTest") ); 
			}
			LogStrm.println("</Transform>");	// <- _ړp
			LogStrm.println( "</Scene>" );
			LogStrm.println( "</X3D>" );
			LogStrm.flush() ;               // Ăł͂߂ďos@KrŌɂ
			LogStrm.close() ; 
		}catch( Exception IOException){ 
			System.out.println("File write error1: TryAgain!!." );
		}


		try{
			//-----t@CJăXg[o͐ƂiPrintWriterNXj
			PrintWriter LogStrm = new  PrintWriter( new FileOutputStream( "Process.xml" ));
			if( (arrangedSuccessfully1 == true) && (snakeCheck1 == true)){
				LogStrm.println( dfp1.getXMLString("routingTest") ); 
			}else if( (arrangedSuccessfully2 == true) && (snakeCheck2 == true) ){
				LogStrm.println( dfp2.getXMLString("routingTest") ); 
			}else if( arrangedSuccessfully0 == true ){
				LogStrm.println( dfp0.getXMLString("routingTest") ); 
			}
			LogStrm.flush() ;               // Ăł͂߂ďos@KrŌɂ
			LogStrm.close() ; 
		}catch( Exception IOException){ 
			System.out.println("File write error1: TryAgain!!."  );
		}

		return( true );
	}


	//-----------------------------------------------
	// pCvgƐڐGŎ\Ȍ`󂩂ǂ𔻒肷
	//-----------------------------------------------
	public boolean isConsistent(){ 
		//------ZpCv`FbN
		for( int indexA = 0; indexA < Coordinates.size()-3; indexA++ ){
			Coordinate coordinateA1 = Coordinates.elementAt( indexA );
			Coordinate coordinateA2 = Coordinates.elementAt( indexA+1 );
			double d = Math.abs( coordinateA2.x - coordinateA1.x );
			d += Math.abs( coordinateA2.y - coordinateA1.y );
			d += Math.abs( coordinateA2.z - coordinateA1.z );
			if( d < (Diameter*1.5) ){ return( false );}
		}
		//-----pCv̎gƂ̊`FbN
		double x_min = 0, x_max = 0, y_min=0, y_max=0, z_min=0, z_max=0 ;
		for( int indexA = 0; indexA < Coordinates.size()-3; indexA++ ){
			Coordinate coordinateA1 = Coordinates.elementAt( indexA );
			Coordinate coordinateA2 = Coordinates.elementAt( indexA+1 );
			double dxA = coordinateA2.x - coordinateA1.x ;
			double dyA = coordinateA2.y - coordinateA1.y ;
			double dzA = coordinateA2.z - coordinateA1.z ;
			if( dxA == 0 ){
				x_min = coordinateA1.x - Diameter/2 ; x_max = coordinateA1.x + Diameter/2 ;
			}else if( dxA > 0 ){
				x_min = coordinateA1.x ; x_max = coordinateA2.x ;
			}else{
				x_min = coordinateA2.x ; x_max = coordinateA1.x ;
			}
			if( dyA == 0 ){
				y_min = coordinateA1.y - Diameter/2 ; y_max = coordinateA1.y + Diameter/2 ;
			}else if( dyA > 0 ){
				y_min = coordinateA1.y ; y_max = coordinateA2.y ;
			}else{
				y_min = coordinateA2.y ; y_max = coordinateA1.y ;
			}
			if( dzA == 0 ){
				z_min = coordinateA1.z - Diameter/2 ; z_max = coordinateA1.z + Diameter/2 ;
			}else if( dzA > 0 ){
				z_min = coordinateA1.z ; z_max = coordinateA2.z ;
			}else{
				z_min = coordinateA2.z ; z_max = coordinateA1.z ;
			}
			for( int indexB = indexA+2; indexB < Coordinates.size()-1; indexB++ ){
				Coordinate coordinateB1 = Coordinates.elementAt( indexB );
				Coordinate coordinateB2 = Coordinates.elementAt( indexB+1 );
				double dxB = coordinateB2.x - coordinateB1.x ;
				double dyB = coordinateB2.y - coordinateB1.y ;
				double dzB = coordinateB2.z - coordinateB1.z ;
				if( dxB > 0 ){
					if( (x_max < coordinateB1.x)||(x_min > coordinateB2.x) ){ continue; }
				}else if( dxB < 0 ){
					if( (x_max < coordinateB2.x)||(x_min > coordinateB1.x) ){ continue; }
				}else{
					if( (x_max < coordinateB2.x - Diameter/2)||(x_min > coordinateB2.x + Diameter/2) ){ continue; }
				}
				if( dyB > 0 ){
					if( (y_max < coordinateB1.y)||(y_min > coordinateB2.y) ){ continue; }
				}else if( dyB < 0 ){
					if( (y_max < coordinateB2.y)||(y_min > coordinateB1.y) ){ continue; }
				}else{
					if( (y_max < coordinateB2.y - Diameter/2)||(y_min > coordinateB2.y + Diameter/2) ){ continue; }
				}
				if( dzB > 0 ){
					if( (z_max < coordinateB1.z)||(z_min > coordinateB2.z) ){ continue; }
				}else if( dzB < 0 ){
					if( (z_max < coordinateB2.z)||(z_min > coordinateB1.z) ){ continue; }
				}else{
					if( (z_max < coordinateB2.z - Diameter/2)||(z_min > coordinateB2.z + Diameter/2) ){ continue; }
				}
				//--------------SĂL̏ɈȂ̈悪dĂ
				return( false );
			}
		}
		return( true );
	}


	public void makePipePieceCheck( Coordinate Coordinates1, Coordinate Coordinates2 ){ 
		ObstacleBox aPipeBox1 = new ObstacleBox() ;
		ObstacleBox aPipeBox2 = new ObstacleBox() ;

		//-----CheckPipePiecesaPipeBox1,2ǉĂ

		Coordinate coordinate1 = Coordinates1;
		Coordinate coordinate2 = Coordinates2;
		double dx = coordinate2.x - coordinate1.x ;		// x̂
		double dy = coordinate2.y - coordinate1.y ;		// ŷ
		double dz = coordinate2.z - coordinate1.z ;		// ẑ

		double absX = Math.abs(dx);		// x̂̐Βl
		double absY = Math.abs(dy);		// ŷ̐Βl
		double absZ = Math.abs(dz);		// ẑ̐Βl

		double x_max = 0, x_min = 0, y_max = 0, y_min = 0, z_max = 0, z_min = 0 ;
		double d = Diameter ;
		if( dx > 0 ){
			x_max = new Double (RoundDouble.round( 4, coordinate2.x)) ;
			x_min = new Double (RoundDouble.round( 4, coordinate1.x)) ;
		}else{
			x_max = new Double (RoundDouble.round( 4, coordinate1.x)) ;
			x_min = new Double (RoundDouble.round( 4, coordinate2.x)) ;
		}
		if( dy > 0 ){
			y_max = new Double (RoundDouble.round( 4, coordinate2.y)) ;
			y_min = new Double (RoundDouble.round( 4, coordinate1.y)) ;
		}else{
			y_max = new Double (RoundDouble.round( 4, coordinate1.y)) ;
			y_min = new Double (RoundDouble.round( 4, coordinate2.y)) ;
		}
		if( dz > 0 ){
			z_max = new Double (RoundDouble.round( 4, coordinate2.z)) ;
			z_min = new Double (RoundDouble.round( 4, coordinate1.z)) ;
		}else{
			z_max = new Double (RoundDouble.round( 4, coordinate1.z)) ;
			z_min = new Double (RoundDouble.round( 4, coordinate2.z)) ;
		}
		double x_mid = (x_min + x_max)*0.5 ;
		double y_mid = (y_min + y_max)*0.5 ;
		double z_mid = (z_min + z_max)*0.5 ;
		double x_Bmid = x_mid + d/2 ;
		double y_Bmid = y_mid + d/2 ;
		double z_Bmid = z_mid + d/2 ;
		double x_Smid = x_mid - d/2 ;
		double y_Smid = y_mid - d/2 ;
		double z_Smid = z_mid - d/2 ;

		double x_tmp_min = x_min + d/2 ;
		double x_tmp_max = x_max - d/2 ;
		double y_tmp_min = y_min + d/2 ;
		double y_tmp_max = y_max - d/2 ;
		double z_tmp_min = z_min + d/2 ;
		double z_tmp_max = z_max - d/2 ;

		if( x_tmp_min >= x_tmp_max ){
			x_tmp_min = x_mid ;
			x_tmp_max = x_mid ;
		}
		if( y_tmp_min >= y_tmp_max ){
			y_tmp_min = y_mid ;
			x_tmp_max = x_mid ;
		}
		if( x_tmp_min >= x_tmp_max ){
			z_tmp_min = z_mid ;
			x_tmp_max = x_mid ;
		}

		//---------pCv𔠂ɕϊۑ------
		if( dx > 0 && absX >= absZ && absX >= absY){
			// pCvxɐLтĂāAx̂ꂪy,ẑ傫Ƃ
			if( dz==0 && dy==0){	
				// zAŷꂪȂƂ
				// G{zu
/**
				aPipeBox1.x_min = x_min ;
				aPipeBox1.x_max = x_max ;
				aPipeBox1.y_min = y_min - d/2 ;
				aPipeBox1.y_max = y_max + d/2 ;
				aPipeBox1.z_min = z_min - d/2 ;
				aPipeBox1.z_max = z_max + d/2 ;
				CheckPipePieces.addElement( aPipeBox1 );
*/
				aPipeBox1.x_min = x_tmp_min ;
				aPipeBox1.x_max = x_tmp_max ;
				aPipeBox1.y_min = y_min - d/2 ;
				aPipeBox1.y_max = y_max + d/2 ;
				aPipeBox1.z_min = z_min - d/2 ;
				aPipeBox1.z_max = z_max + d/2 ;
				CheckPipePieces.addElement( aPipeBox1 );
			}else if( (dz != 0) && (dy == 0) ){
				// zɂĂƂ
				// xhzu
				if( dz < 0 ){
					aPipeBox1.x_min = x_min ;
					aPipeBox1.x_max = x_mid ;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_max + d/2 ;
					aPipeBox1.z_min = z_Smid ;
					aPipeBox1.z_max = z_max + d/2;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_mid ;
					aPipeBox2.x_max = x_max ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_Bmid ;
					CheckPipePieces.addElement( aPipeBox2 );

				}else if( dz > 0){
					aPipeBox1.x_min = x_min ;
					aPipeBox1.x_max = x_mid ;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_max + d/2 ;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_Bmid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_mid ;
					aPipeBox2.x_max = x_max ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_Smid ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );

				}

			}else if( dz == 0 && dy != 0 ){
				// yɂĂƂ
				// xhzu
				if( dy < 0 ){
					aPipeBox1.x_min = x_min ;
					aPipeBox1.x_max = x_mid ;
					aPipeBox1.y_min = y_Smid ;
					aPipeBox1.y_max = y_max + d/2;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_mid ;
					aPipeBox2.x_max = x_max ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_Bmid ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );
				}else if( dy > 0){
					aPipeBox1.x_min = x_min ;
					aPipeBox1.x_max = x_mid ;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_Bmid ;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_mid ;
					aPipeBox2.x_max = x_max ;
					aPipeBox2.y_min = y_Smid ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );

				}
			}

		}else if( dx < 0 && absX >= absZ && absX >= absY){
			// pCvxɐLтĂāAx̂ꂪy,ẑ傫Ƃ
			if( dz == 0 && dy == 0){
				// zAŷꂪȂƂ
				// G{zu
/**
				aPipeBox1.x_min = x_min ;
				aPipeBox1.x_max = x_max ;
				aPipeBox1.y_min = y_min - d/2 ;
				aPipeBox1.y_max = y_max + d/2 ;
				aPipeBox1.z_min = z_min - d/2 ;
				aPipeBox1.z_max = z_max + d/2 ;
				CheckPipePieces.addElement( aPipeBox1 );
*/
				aPipeBox1.x_min = x_tmp_min ;
				aPipeBox1.x_max = x_tmp_max ;
				aPipeBox1.y_min = y_min - d/2 ;
				aPipeBox1.y_max = y_max + d/2 ;
				aPipeBox1.z_min = z_min - d/2 ;
				aPipeBox1.z_max = z_max + d/2 ;
				CheckPipePieces.addElement( aPipeBox1 );
			}else if( dz != 0 && dy == 0 ){
				// zɂĂƂ
				// xhzu
				if( dz < 0 ){
					aPipeBox1.x_min = x_min ;
					aPipeBox1.x_max = x_mid ;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_max + d/2 ;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_Bmid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_mid ;
					aPipeBox2.x_max = x_max ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_Smid ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );
				}else if( dz > 0){
					aPipeBox1.x_min = x_min ;
					aPipeBox1.x_max = x_mid ;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_max + d/2 ;
					aPipeBox1.z_min = z_Smid ;
					aPipeBox1.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_mid ;
					aPipeBox2.x_max = x_max ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_Bmid ;
					CheckPipePieces.addElement( aPipeBox2 );
				}

			}else if( dz == 0 && dy != 0 ){
				// yɂĂƂ
				//xhzu
				if( dy < 0 ){
					aPipeBox1.x_min = x_min ;
					aPipeBox1.x_max = x_mid ;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_Bmid ;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_mid ;
					aPipeBox2.x_max = x_max ;
					aPipeBox2.y_min = y_Smid ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );
				}else if( dy > 0){
					aPipeBox1.x_min = x_min ;
					aPipeBox1.x_max = x_mid ;
					aPipeBox1.y_min = y_Smid ;
					aPipeBox1.y_max = y_max + d/2;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_mid ;
					aPipeBox2.x_max = x_max ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_Bmid ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );
				}
			}

		}else if( dy > 0 && absY >= absZ && absY >= absX){
			// pCvyɐLтĂāAŷꂪx,ẑ傫Ƃ
			if( dx == 0 && dz == 0){
				// xAẑꂪȂƂ
				//G{zu
/**
				aPipeBox1.x_min = x_min - d/2 ;
				aPipeBox1.x_max = x_max + d/2 ;
				aPipeBox1.y_min = y_min ;
				aPipeBox1.y_max = y_max ;
				aPipeBox1.z_min = z_min - d/2 ;
				aPipeBox1.z_max = z_max + d/2 ;
				CheckPipePieces.addElement( aPipeBox1 );
*/
				aPipeBox1.x_min = x_min - d/2 ;
				aPipeBox1.x_max = x_max + d/2 ;
				aPipeBox1.y_min = y_tmp_min ;
				aPipeBox1.y_max = y_tmp_max ;
				aPipeBox1.z_min = z_min - d/2 ;
				aPipeBox1.z_max = z_max + d/2 ;
				CheckPipePieces.addElement( aPipeBox1 );
			}else if( dx != 0 && dz == 0 ){
				// xɂĂƂ
				//xhzu
				if( dx < 0 ){
					aPipeBox1.x_min = x_Smid ;
					aPipeBox1.x_max = x_max + d/2;
					aPipeBox1.y_min = y_min ;
					aPipeBox1.y_max = y_mid ;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_Bmid ;
					aPipeBox2.y_min = y_mid ;
					aPipeBox2.y_max = y_max ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );
				}else if( dx > 0){
					aPipeBox1.y_min = y_min ;
					aPipeBox1.y_max = y_mid ;
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_Bmid ;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.y_min = y_mid ;
					aPipeBox2.y_max = y_max ;
					aPipeBox2.x_min = x_Smid ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );

				}

			}else if( dx == 0 && dz != 0 ){
				// zɂĂƂ
				//xhzu
				if( dz < 0 ){
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_max + d/2 ;
					aPipeBox1.y_min = y_min ;
					aPipeBox1.y_max = y_mid ;
					aPipeBox1.z_min = z_Smid ;
					aPipeBox1.z_max = z_max + d/2;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.y_min = y_mid ;
					aPipeBox2.y_max = y_max ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_Bmid ;
					CheckPipePieces.addElement( aPipeBox2 );
				}else if( dz > 0){
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_max + d/2 ;
					aPipeBox1.y_min = y_min ;
					aPipeBox1.y_max = y_mid ;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_Bmid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.y_min = y_mid ;
					aPipeBox2.y_max = y_max ;
					aPipeBox2.z_min = z_Smid ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );

				}
			}

		}else if( dy < 0 && absY >= absX && absY >= absZ){
			// pCvyɐLтĂāAŷꂪx,ẑ傫Ƃ
			if( dx == 0 && dz == 0){
				// xAẑꂪȂƂ
				// G{zu
/**
				aPipeBox1.x_min = x_min - d/2 ;
				aPipeBox1.x_max = x_max + d/2 ;
				aPipeBox1.y_min = y_min ;
				aPipeBox1.y_max = y_max ;
				aPipeBox1.z_min = z_min - d/2 ;
				aPipeBox1.z_max = z_max + d/2 ;
				CheckPipePieces.addElement( aPipeBox1 );
*/
				aPipeBox1.x_min = x_min - d/2 ;
				aPipeBox1.x_max = x_max + d/2 ;
				aPipeBox1.y_min = y_tmp_min ;
				aPipeBox1.y_max = y_tmp_max ;
				aPipeBox1.z_min = z_min - d/2 ;
				aPipeBox1.z_max = z_max + d/2 ;
				CheckPipePieces.addElement( aPipeBox1 );
			}else if( dx != 0 && dz == 0){
				// xɂĂƂ
				// xhzu
				if( dx < 0 ){
					aPipeBox1.y_min = y_min ;
					aPipeBox1.y_max = y_mid ;
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_Bmid ;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.y_min = y_mid ;
					aPipeBox2.y_max = y_max ;
					aPipeBox2.x_min = x_Smid ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );

				}else if( dx > 0){
					aPipeBox1.x_min = x_Smid ;
					aPipeBox1.x_max = x_max + d/2;
					aPipeBox1.y_min = y_min ;
					aPipeBox1.y_max = y_mid ;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_Bmid ;
					aPipeBox2.y_min = y_mid ;
					aPipeBox2.y_max = y_max ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );
				}

			}else if( dx == 0 && dz != 0){
				// zɂĂƂ
				//xhzu
				if( dz < 0 ){
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_max + d/2 ;
					aPipeBox1.y_min = y_min ;
					aPipeBox1.y_max = y_mid ;
					aPipeBox1.z_min = z_min - d/2 ;
					aPipeBox1.z_max = z_Bmid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.y_min = y_mid ;
					aPipeBox2.y_max = y_max ;
					aPipeBox2.z_min = z_Smid ;
					aPipeBox2.z_max = z_max + d/2 ;
					CheckPipePieces.addElement( aPipeBox2 );

				}else if( dz > 0){
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_max + d/2 ;
					aPipeBox1.y_min = y_min ;
					aPipeBox1.y_max = y_mid ;
					aPipeBox1.z_min = z_Smid ;
					aPipeBox1.z_max = z_max + d/2;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.y_min = y_mid ;
					aPipeBox2.y_max = y_max ;
					aPipeBox2.z_min = z_min - d/2 ;
					aPipeBox2.z_max = z_Bmid ;
					CheckPipePieces.addElement( aPipeBox2 );
				}
			}

		}else if( dz > 0 && absZ >= absX && absZ >= absY){
			// pCvzɐLтĂāAẑꂪx,ŷ傫Ƃ
			if( dx == 0 && dy == 0){
				// xAŷꂪȂƂ
				// G{zu
/**
				aPipeBox1.x_min = x_min - d/2 ;
				aPipeBox1.x_max = x_max + d/2 ;
				aPipeBox1.y_min = y_min - d/2 ;
				aPipeBox1.y_max = y_max + d/2 ;
				aPipeBox1.z_min = z_min ;
				aPipeBox1.z_max = z_max ;
*/
				aPipeBox1.x_min = x_min - d/2 ;
				aPipeBox1.x_max = x_max + d/2 ;
				aPipeBox1.y_min = y_min - d/2 ;
				aPipeBox1.y_max = y_max + d/2 ;
				aPipeBox1.z_min = z_tmp_min ;
				aPipeBox1.z_max = z_tmp_max ;
				CheckPipePieces.addElement( aPipeBox1 );
			}else if( dx != 0 && dy == 0){
				// xɂĂƂ
				// xhzu
				if( dx < 0 ){
					aPipeBox1.x_min = x_Smid ;
					aPipeBox1.x_max = x_max + d/2;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_max + d/2 ;
					aPipeBox1.z_min = z_min ;
					aPipeBox1.z_max = z_mid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_Bmid ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_mid ;
					aPipeBox2.z_max = z_max ;
					CheckPipePieces.addElement( aPipeBox2 );

				}else if( dx > 0){
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_Bmid ;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_max + d/2 ;
					aPipeBox1.z_min = z_min ;
					aPipeBox1.z_max = z_mid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_Smid ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_mid ;
					aPipeBox2.z_max = z_max ;
					CheckPipePieces.addElement( aPipeBox2 );
				}

			}else if( dx == 0 && dy != 0){
				// yɂĂƂ
				//xhzu
				if( dy < 0 ){
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_max + d/2 ;
					aPipeBox1.y_min = y_Smid ;
					aPipeBox1.y_max = y_max + d/2;
					aPipeBox1.z_min = z_min ;
					aPipeBox1.z_max = z_mid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_Bmid ;
					aPipeBox2.z_min = z_mid ;
					aPipeBox2.z_max = z_max ;
					CheckPipePieces.addElement( aPipeBox2 );

				}else if( dy > 0){
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_max + d/2 ;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_Bmid ;
					aPipeBox1.z_min = z_min ;
					aPipeBox1.z_max = z_mid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.y_min = y_Smid ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_mid ;
					aPipeBox2.z_max = z_max ;
					CheckPipePieces.addElement( aPipeBox2 );
				}
			}

		}else if( dz < 0 && absZ >= absX && absZ >= absY){
			// pCvzɐLтĂāAẑꂪx,ŷ傫Ƃ
			if( dx == 0 && dy == 0){
				// xAŷꂪȂƂ
				//G{zu
/**
				aPipeBox1.x_min = x_min - d/2 ;
				aPipeBox1.x_max = x_max + d/2 ;
				aPipeBox1.y_min = y_min - d/2 ;
				aPipeBox1.y_max = y_max + d/2 ;
				aPipeBox1.z_min = z_min ;
				aPipeBox1.z_max = z_max ;
*/
				aPipeBox1.x_min = x_min - d/2 ;
				aPipeBox1.x_max = x_max + d/2 ;
				aPipeBox1.y_min = y_min - d/2 ;
				aPipeBox1.y_max = y_max + d/2 ;
				aPipeBox1.z_min = z_tmp_min ;
				aPipeBox1.z_max = z_tmp_max ;
				CheckPipePieces.addElement( aPipeBox1 );
			}else if( dx != 0 && dy == 0 ){
				// xɂĂƂ
				//xhzu
				if( dx < 0 ){
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_Bmid ;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_max + d/2 ;
					aPipeBox1.z_min = z_min ;
					aPipeBox1.z_max = z_mid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_Smid ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_mid ;
					aPipeBox2.z_max = z_max ;
					CheckPipePieces.addElement( aPipeBox2 );
				}else if( dx > 0){
					aPipeBox1.x_min = x_Smid ;
					aPipeBox1.x_max = x_max + d/2;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_max + d/2 ;
					aPipeBox1.z_min = z_min ;
					aPipeBox1.z_max = z_mid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_Bmid ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_mid ;
					aPipeBox2.z_max = z_max ;
					CheckPipePieces.addElement( aPipeBox2 );
				}

			}else if( dx == 0 && dy != 0 ){
				// yɂĂƂ
				//xhzu
				if( dy < 0 ){
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_max + d/2 ;
					aPipeBox1.y_min = y_min - d/2 ;
					aPipeBox1.y_max = y_Bmid ;
					aPipeBox1.z_min = z_min ;
					aPipeBox1.z_max = z_mid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.y_min = y_Smid ;
					aPipeBox2.y_max = y_max + d/2 ;
					aPipeBox2.z_min = z_mid ;
					aPipeBox2.z_max = z_max ;
					CheckPipePieces.addElement( aPipeBox2 );
				}else if( dy > 0){
					aPipeBox1.x_min = x_min - d/2 ;
					aPipeBox1.x_max = x_max + d/2 ;
					aPipeBox1.y_min = y_Smid ;
					aPipeBox1.y_max = y_max + d/2;
					aPipeBox1.z_min = z_min ;
					aPipeBox1.z_max = z_mid ;
					CheckPipePieces.addElement( aPipeBox1 );

					aPipeBox2.x_min = x_min - d/2 ;
					aPipeBox2.x_max = x_max + d/2 ;
					aPipeBox2.y_min = y_min - d/2 ;
					aPipeBox2.y_max = y_Bmid ;
					aPipeBox2.z_min = z_mid ;
					aPipeBox2.z_max = z_max ;
					CheckPipePieces.addElement( aPipeBox2 );

				}
			}

		}else if(dx == 0 && dy == 0 && dz == 0){
//					System.out.println("dx == 0 && dy == 0 && dz == 0");
		}
	}

	public boolean isConsistent2(){
		//-----newpCv̎gƂ̊`FbN
		CheckPipePieces = new Vector<ObstacleBox>() ;
		double d = Diameter ;
		//-----CheckPipePiece쐬
		for( int index = 0; index < Coordinates.size()-1; index++ ){
			Coordinate coordinate1 = Coordinates.elementAt( index );
			Coordinate coordinate2 = Coordinates.elementAt( index+1 );
			double dx = coordinate2.x - coordinate1.x ;
			double dy = coordinate2.y - coordinate1.y ;
			double dz = coordinate2.z - coordinate1.z ;
			if( (Math.abs(dx) <= d/2 ) && (Math.abs(dy) <= d/2) && (Math.abs(dz) <= d/2) ){
//System.out.println( "Num of index = " + index ) ;
//System.out.println( "coordinate1.x = " + coordinate1.x ) ;
//System.out.println( "coordinate2.x = " + coordinate2.x ) ;
//System.out.println( "coordinate1.y = " + coordinate1.y ) ;
//System.out.println( "coordinate2.y = " + coordinate2.y ) ;
//System.out.println( "coordinate1.z = " + coordinate1.z ) ;
//System.out.println( "coordinate2.z = " + coordinate2.z ) ;
				// --- ZpCv͖
				continue ;
			}
			makePipePieceCheck( coordinate1, coordinate2 );
		}
System.out.println( "				CheckPipePieces.size() = " + CheckPipePieces.size() ) ;
		boolean checkFlag = true ;
		while( checkFlag ){
			if( CheckPipePieces.size() < 2 ){
				CheckPipePieces.removeAllElements() ;
				return( true ) ;
			}
			ObstacleBox aPipeBox = CheckPipePieces.elementAt( 0 ) ;
			double x_tmp_min = new Double( RoundDouble.round( 4, aPipeBox.x_min )) ;
			double x_tmp_max = new Double( RoundDouble.round( 4, aPipeBox.x_max )) ;
			double y_tmp_min = new Double( RoundDouble.round( 4, aPipeBox.y_min )) ;
			double y_tmp_max = new Double( RoundDouble.round( 4, aPipeBox.y_max )) ;
			double z_tmp_min = new Double( RoundDouble.round( 4, aPipeBox.z_min )) ;
			double z_tmp_max = new Double( RoundDouble.round( 4, aPipeBox.z_max )) ;
			CheckPipePieces.remove( 0 ) ;

			for( int index = 0; index < CheckPipePieces.size() ; index++ ){
				ObstacleBox aPipeBox2 = CheckPipePieces.elementAt( index ) ;
				if( aPipeBox2.interfere( x_tmp_min, x_tmp_max, y_tmp_min, y_tmp_max, z_tmp_min, z_tmp_max ) ){
System.out.println( " Interfered PipePieces are " ) ;
System.out.println(x_tmp_min +  " " + x_tmp_max + " " + y_tmp_min + " " + y_tmp_max + " " + z_tmp_min + " " + z_tmp_max ) ;
System.out.println( " And " ) ;
System.out.println(aPipeBox2.x_min +  " " + aPipeBox2.x_max + " " + aPipeBox2.y_min + " " + aPipeBox2.y_max + " " + aPipeBox2.z_min + " " + aPipeBox2.z_max ) ;
System.out.println( "" ) ;
//					CheckPipePieces.removeAllElements() ;
					return( false );
				}
			}
		}
		return( true ) ;
	}


	public static  short OBSTACLE   = -1 ;
	public static  short NONLABELED =  0 ;
	//------------݌vΏۂ̋ԂɂĈŎꂽ`̒ɏQ邩ǂ𔻒
	public short judge( double x_min, double x_max, double y_min, double y_max, double z_min, double z_max, AllItems allItems ){

		for( int index = 0; index < allItems.pid.ObstacleBoxes.size(); index++ ){
			ObstacleBox anObstacleBox = allItems.pid.ObstacleBoxes.elementAt( index );
			if( anObstacleBox.interfere( x_min, x_max, y_min, y_max, z_min, z_max ) ){
				return( OBSTACLE );
			}
		}

		for( int index = 0; index < allItems.pid.ObstacleTriangles.size(); index++ ){
			ObstacleTriangle anObstacleTriangle = allItems.pid.ObstacleTriangles.elementAt( index );
			if( anObstacleTriangle.interfere( x_min, x_max, y_min, y_max, z_min, z_max ) ){
				return( OBSTACLE );
			}
		}

		for( int index = 0; index < allItems.PipeLines.size(); index++ ){
			PipeLine aPipeLine = allItems.PipeLines.elementAt( index );

			for( int index_t = 0; index_t < aPipeLine.Pipes.size(); index_t++ ){
				Pipe aPipe = aPipeLine.Pipes.elementAt( index_t );
				double d = aPipe.Diameter ;

				for( int index_p = 0; index_p < aPipe.PipePieces.size(); index_p++ ){
					PipePiece aPipePiece = aPipe.PipePieces.elementAt( index_p ) ;
					if( aPipePiece.interfere1( x_min, x_max, y_min, y_max, z_min, z_max, d ) ){
						return( OBSTACLE );
					}
				}

			}

		}

		return( NONLABELED );
	}


}
