// 
// zǌn}\pCvȊO̗vfiQj\NX
// 
// PipeLine.java
// 
// 
// 
// 
// Bww@Hw@CmVXeHw
// ؑ@
// kimura@nams.kyushu-u.ac.jp
// http://sysplan.nams.kyushu-u.ac.jp/gen/index.html
//
//---------------------------------------------------

import java.lang.Math ;
import java.io.* ;
import java.util.*;
// import MT19937 ; // double uniformRandomNumber  = MT19937.uniform() ; // 0-1̈l

import javax.xml.parsers.*;  // XMLp|T[֘ÃNX
import org.w3c.dom.*;        // XMLp|T[֘ÃNX


//-----------------------------------------

public class PipeLine {

	//------ϐ
	public double x_min ;
	public double x_max ;
	public double y_min ;
	public double y_max ;
	public double z_min ;
	public double z_max ;
	public String Specification ;
	public String pid ;
	public String Attribute ;
	public Vector<Pipe> Pipes;

	//-----------------------RXgN^
	PipeLine(){
		Specification = "" ;
		Pipes = new Vector<Pipe>() ;
	}
	//----------------------------------------------
	// XMLp[T"PipeLine"ƃxtꂽ
	// m[hElementlǂݍ
	//----------------------------------------------
	public void loadFromXMLelement( Element PipeLineElement ){
		// pid̒l擾
		pid = PipeLineElement.getAttribute("pid").trim();
//		System.out.println( "pid = " + pid );
		//----Specificationvf̃Xg擾
		NodeList list_Specification = PipeLineElement.getElementsByTagName("Specification");
		// ŏSpecificationǂݍ
		if( list_Specification.getLength() > 0 ){
			// Specificationvf擾
			Element element = (Element)list_Specification.item(0);
			// Specificationvf̍ŏ̎qm[hieLXgm[hj̒l擾
			Specification = element.getFirstChild().getNodeValue();
		}
		//----Attributevf̃Xg擾
		NodeList list_Attribute = PipeLineElement.getElementsByTagName("Attribute");
		// ŏAttributeǂݍ
		if( list_Attribute.getLength() > 0 ){
			// Attributevf擾
			Element element = (Element)list_Attribute.item(0);
			// Attributevf̍ŏ̎qm[hieLXgm[hj̒l擾
			Attribute = element.getFirstChild().getNodeValue();
		}
		//----Pipevf̃Xg擾
		NodeList list_Pipe = PipeLineElement.getElementsByTagName("Pipe");
		// Pipevf̐[v
		for (int i=0; i < list_Pipe.getLength() ; i++) {
			Pipe aPipe = new Pipe() ; // 
			Element PipeElement = (Element)list_Pipe.item(i);
			//-----XMLp[T"Pipe"ƃxtꂽm[hElementlǂݍ
			aPipe.loadFromXMLelement( PipeElement );
			Pipes.addElement( aPipe );
		} 
//System.out.println("Paipu no Honsu = " + Pipes.size() );




			



	}

	//-----------------------------------------------
	// ڐG̔ ̔ƐڐGĂtrueԂ
	//-----------------------------------------------
	public boolean interfere( double ix_min, double ix_max, double iy_min, double iy_max, double iz_min, double iz_max ){ 
		if( ix_min >= x_max ){ return( false );}
		if( ix_max <= x_min ){ return( false );}
		if( iy_min >= y_max ){ return( false );}
		if( iy_max <= y_min ){ return( false );}
		if( iz_min >= z_max ){ return( false );}
		if( iz_max <= z_min ){ return( false );}
		return( true );
	}


	//----------------------------------------------
	public String getXMLString(){
		StringBuffer strBuf = new StringBuffer() ;
		if( pid == null){
			strBuf.append("<PipeLine> \n" );
		}else{
			strBuf.append("<PipeLine pid=\"" ).append( pid ).append("\" > \n" );
		}
		if( Specification.length() > 0 ){
			strBuf.append("<Specification>").append( Specification ).append("</Specification> \n") ;
		}
		if( Attribute.length() > 0 ){
			strBuf.append("<Attribute>").append( Attribute ).append("</Attribute> \n") ;
		}
		//--- Pipes
		for( int index = 0; index < Pipes.size(); index++ ){
			Pipe aPipe = Pipes.elementAt( index );
			strBuf.append( aPipe.getXMLString() );
		}
		strBuf.append("</PipeLine> \n" );
		return( strBuf.toString() );
	}
	//----------------------------------------------
	public String getX3DString(){
		StringBuffer strBuf = new StringBuffer() ;

		double width  = x_max - x_min ;
		double height = z_max - z_min ;
		double depth  = y_max - y_min ;
		//--- Pipes
		for( int index = 0; index < Pipes.size(); index++ ){
			Pipe aPipe = Pipes.elementAt( index );
			strBuf.append( aPipe.getX3DString() );
		}

		return( strBuf.toString() );
	}


}
